#line 2 "src/backend/parser/ag_scanner.c"
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/*
 * The rules in this scanner implementation are based on the followings.
 *
 *     - openCypher
 *           - Cypher Query Language Reference (Version 9)
 *           - Grammar Specification (M13)
 *           - ANTLR Grammar (M13)
 *     - JSON (RFC 8259)
 */

#include "postgres.h"

#include "common/string.h"
#include "mb/pg_wchar.h"

#include "parser/ag_scanner.h"

#line 39 "src/backend/parser/ag_scanner.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 1
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* An opaque pointer. */
#ifndef YY_TYPEDEF_YY_SCANNER_T
#define YY_TYPEDEF_YY_SCANNER_T
typedef void* yyscan_t;
#endif

/* For convenience, these vars (plus the bison vars far below)
   are macros in the reentrant scanner. */
#define yyin yyg->yyin_r
#define yyout yyg->yyout_r
#define yyextra yyg->yyextra_r
#define yyleng yyg->yyleng_r
#define yytext yyg->yytext_r
#define yylineno (YY_CURRENT_BUFFER_LVALUE->yy_bs_lineno)
#define yycolumn (YY_CURRENT_BUFFER_LVALUE->yy_bs_column)
#define yy_flex_debug yyg->yy_flex_debug_r

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yyg->yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yyg->yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE ag_yyrestart(yyin ,yyscanner )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        yy_size_t yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = yyg->yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yyg->yy_c_buf_p = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yyg->yytext_ptr , yyscanner )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via ag_yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( yyg->yy_buffer_stack \
                          ? yyg->yy_buffer_stack[yyg->yy_buffer_stack_top] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE yyg->yy_buffer_stack[yyg->yy_buffer_stack_top]

void ag_yyrestart (FILE *input_file ,yyscan_t yyscanner );
void ag_yy_switch_to_buffer (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
YY_BUFFER_STATE ag_yy_create_buffer (FILE *file,int size ,yyscan_t yyscanner );
void ag_yy_delete_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void ag_yy_flush_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void ag_yypush_buffer_state (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
void ag_yypop_buffer_state (yyscan_t yyscanner );

static void ag_yyensure_buffer_stack (yyscan_t yyscanner );
static void ag_yy_load_buffer_state (yyscan_t yyscanner );
static void ag_yy_init_buffer (YY_BUFFER_STATE b,FILE *file ,yyscan_t yyscanner );

#define YY_FLUSH_BUFFER ag_yy_flush_buffer(YY_CURRENT_BUFFER ,yyscanner)

YY_BUFFER_STATE ag_yy_scan_buffer (char *base,yy_size_t size ,yyscan_t yyscanner );
YY_BUFFER_STATE ag_yy_scan_string (yyconst char *yy_str ,yyscan_t yyscanner );
YY_BUFFER_STATE ag_yy_scan_bytes (yyconst char *bytes,int len ,yyscan_t yyscanner );

void *ag_yyalloc (yy_size_t ,yyscan_t yyscanner );
void *ag_yyrealloc (void *,yy_size_t ,yyscan_t yyscanner );
void ag_yyfree (void * ,yyscan_t yyscanner );

#define yy_new_buffer ag_yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        ag_yyensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            ag_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        ag_yyensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            ag_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define ag_yywrap(yyscanner) (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

typedef yyconst struct yy_trans_info *yy_state_type;

#define yytext_ptr yytext_r

static yy_state_type yy_get_previous_state (yyscan_t yyscanner );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  ,yyscan_t yyscanner);
static int yy_get_next_buffer (yyscan_t yyscanner );
static void yynoreturn yy_fatal_error (yyconst char* msg ,yyscan_t yyscanner );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yyg->yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yyg->yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yyg->yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 41
#define YY_END_OF_BUFFER 42
struct yy_trans_info
	{
	flex_int16_t yy_verify;
	flex_int16_t yy_nxt;
	};
static yyconst struct yy_trans_info yy_transition[9056] =
    {
 {   0,   0 }, {   0,8800 }, {   0,   0 }, {   0,8798 }, {   1,3096 },
 {   2,3096 }, {   3,3096 }, {   4,3096 }, {   5,3096 }, {   6,3096 },
 {   7,3096 }, {   8,3096 }, {   9,3098 }, {  10,3103 }, {  11,3098 },
 {  12,3098 }, {  13,3098 }, {  14,3096 }, {  15,3096 }, {  16,3096 },
 {  17,3096 }, {  18,3096 }, {  19,3096 }, {  20,3096 }, {  21,3096 },
 {  22,3096 }, {  23,3096 }, {  24,3096 }, {  25,3096 }, {  26,3096 },
 {  27,3096 }, {  28,3096 }, {  29,3096 }, {  30,3096 }, {  31,3096 },
 {  32,3098 }, {  33,3096 }, {  34,3100 }, {  35,3096 }, {  36,3105 },
 {  37,3118 }, {  38,3096 }, {  39,3120 }, {  40,3118 }, {  41,3118 },
 {  42,3118 }, {  43,3137 }, {  44,3118 }, {  45,3118 }, {  46,3362 },

 {  47,3154 }, {  48,3374 }, {  49,3396 }, {  50,3396 }, {  51,3396 },
 {  52,3396 }, {  53,3396 }, {  54,3396 }, {  55,3396 }, {  56,3396 },
 {  57,3396 }, {  58,3376 }, {  59,3118 }, {  60,3378 }, {  61,3380 },
 {  62,3393 }, {  63,3096 }, {  64,3096 }, {  65,3459 }, {  66,3459 },
 {  67,3459 }, {  68,3459 }, {  69,3459 }, {  70,3459 }, {  71,3459 },
 {  72,3459 }, {  73,3459 }, {  74,3459 }, {  75,3459 }, {  76,3459 },
 {  77,3459 }, {  78,3459 }, {  79,3459 }, {  80,3459 }, {  81,3459 },
 {  82,3459 }, {  83,3459 }, {  84,3459 }, {  85,3459 }, {  86,3459 },
 {  87,3459 }, {  88,3459 }, {  89,3459 }, {  90,3459 }, {  91,3118 },
 {  92,3096 }, {  93,3118 }, {  94,3118 }, {  95,3459 }, {  96,3398 },

 {  97,3459 }, {  98,3459 }, {  99,3459 }, { 100,3459 }, { 101,3459 },
 { 102,3459 }, { 103,3459 }, { 104,3459 }, { 105,3459 }, { 106,3459 },
 { 107,3459 }, { 108,3459 }, { 109,3459 }, { 110,3459 }, { 111,3459 },
 { 112,3459 }, { 113,3459 }, { 114,3459 }, { 115,3459 }, { 116,3459 },
 { 117,3459 }, { 118,3459 }, { 119,3459 }, { 120,3459 }, { 121,3459 },
 { 122,3459 }, { 123,3118 }, { 124,3118 }, { 125,3118 }, { 126,3096 },
 { 127,3096 }, { 128,3459 }, { 129,3459 }, { 130,3459 }, { 131,3459 },
 { 132,3459 }, { 133,3459 }, { 134,3459 }, { 135,3459 }, { 136,3459 },
 { 137,3459 }, { 138,3459 }, { 139,3459 }, { 140,3459 }, { 141,3459 },
 { 142,3459 }, { 143,3459 }, { 144,3459 }, { 145,3459 }, { 146,3459 },

 { 147,3459 }, { 148,3459 }, { 149,3459 }, { 150,3459 }, { 151,3459 },
 { 152,3459 }, { 153,3459 }, { 154,3459 }, { 155,3459 }, { 156,3459 },
 { 157,3459 }, { 158,3459 }, { 159,3459 }, { 160,3459 }, { 161,3459 },
 { 162,3459 }, { 163,3459 }, { 164,3459 }, { 165,3459 }, { 166,3459 },
 { 167,3459 }, { 168,3459 }, { 169,3459 }, { 170,3459 }, { 171,3459 },
 { 172,3459 }, { 173,3459 }, { 174,3459 }, { 175,3459 }, { 176,3459 },
 { 177,3459 }, { 178,3459 }, { 179,3459 }, { 180,3459 }, { 181,3459 },
 { 182,3459 }, { 183,3459 }, { 184,3459 }, { 185,3459 }, { 186,3459 },
 { 187,3459 }, { 188,3459 }, { 189,3459 }, { 190,3459 }, { 191,3459 },
 { 192,3459 }, { 193,3459 }, { 194,3459 }, { 195,3459 }, { 196,3459 },

 { 197,3459 }, { 198,3459 }, { 199,3459 }, { 200,3459 }, { 201,3459 },
 { 202,3459 }, { 203,3459 }, { 204,3459 }, { 205,3459 }, { 206,3459 },
 { 207,3459 }, { 208,3459 }, { 209,3459 }, { 210,3459 }, { 211,3459 },
 { 212,3459 }, { 213,3459 }, { 214,3459 }, { 215,3459 }, { 216,3459 },
 { 217,3459 }, { 218,3459 }, { 219,3459 }, { 220,3459 }, { 221,3459 },
 { 222,3459 }, { 223,3459 }, { 224,3459 }, { 225,3459 }, { 226,3459 },
 { 227,3459 }, { 228,3459 }, { 229,3459 }, { 230,3459 }, { 231,3459 },
 { 232,3459 }, { 233,3459 }, { 234,3459 }, { 235,3459 }, { 236,3459 },
 { 237,3459 }, { 238,3459 }, { 239,3459 }, { 240,3459 }, { 241,3459 },
 { 242,3459 }, { 243,3459 }, { 244,3459 }, { 245,3459 }, { 246,3459 },

 { 247,3459 }, { 248,3459 }, { 249,3459 }, { 250,3459 }, { 251,3459 },
 { 252,3459 }, { 253,3459 }, { 254,3459 }, { 255,3459 }, { 256,3096 },
 {   0,   0 }, {   0,8540 }, {   1,2838 }, {   2,2838 }, {   3,2838 },
 {   4,2838 }, {   5,2838 }, {   6,2838 }, {   7,2838 }, {   8,2838 },
 {   9,2840 }, {  10,2845 }, {  11,2840 }, {  12,2840 }, {  13,2840 },
 {  14,2838 }, {  15,2838 }, {  16,2838 }, {  17,2838 }, {  18,2838 },
 {  19,2838 }, {  20,2838 }, {  21,2838 }, {  22,2838 }, {  23,2838 },
 {  24,2838 }, {  25,2838 }, {  26,2838 }, {  27,2838 }, {  28,2838 },
 {  29,2838 }, {  30,2838 }, {  31,2838 }, {  32,2840 }, {  33,2838 },
 {  34,2842 }, {  35,2838 }, {  36,2847 }, {  37,2860 }, {  38,2838 },

 {  39,2862 }, {  40,2860 }, {  41,2860 }, {  42,2860 }, {  43,2879 },
 {  44,2860 }, {  45,2860 }, {  46,3104 }, {  47,2896 }, {  48,3116 },
 {  49,3138 }, {  50,3138 }, {  51,3138 }, {  52,3138 }, {  53,3138 },
 {  54,3138 }, {  55,3138 }, {  56,3138 }, {  57,3138 }, {  58,3118 },
 {  59,2860 }, {  60,3120 }, {  61,3122 }, {  62,3135 }, {  63,2838 },
 {  64,2838 }, {  65,3201 }, {  66,3201 }, {  67,3201 }, {  68,3201 },
 {  69,3201 }, {  70,3201 }, {  71,3201 }, {  72,3201 }, {  73,3201 },
 {  74,3201 }, {  75,3201 }, {  76,3201 }, {  77,3201 }, {  78,3201 },
 {  79,3201 }, {  80,3201 }, {  81,3201 }, {  82,3201 }, {  83,3201 },
 {  84,3201 }, {  85,3201 }, {  86,3201 }, {  87,3201 }, {  88,3201 },

 {  89,3201 }, {  90,3201 }, {  91,2860 }, {  92,2838 }, {  93,2860 },
 {  94,2860 }, {  95,3201 }, {  96,3140 }, {  97,3201 }, {  98,3201 },
 {  99,3201 }, { 100,3201 }, { 101,3201 }, { 102,3201 }, { 103,3201 },
 { 104,3201 }, { 105,3201 }, { 106,3201 }, { 107,3201 }, { 108,3201 },
 { 109,3201 }, { 110,3201 }, { 111,3201 }, { 112,3201 }, { 113,3201 },
 { 114,3201 }, { 115,3201 }, { 116,3201 }, { 117,3201 }, { 118,3201 },
 { 119,3201 }, { 120,3201 }, { 121,3201 }, { 122,3201 }, { 123,2860 },
 { 124,2860 }, { 125,2860 }, { 126,2838 }, { 127,2838 }, { 128,3201 },
 { 129,3201 }, { 130,3201 }, { 131,3201 }, { 132,3201 }, { 133,3201 },
 { 134,3201 }, { 135,3201 }, { 136,3201 }, { 137,3201 }, { 138,3201 },

 { 139,3201 }, { 140,3201 }, { 141,3201 }, { 142,3201 }, { 143,3201 },
 { 144,3201 }, { 145,3201 }, { 146,3201 }, { 147,3201 }, { 148,3201 },
 { 149,3201 }, { 150,3201 }, { 151,3201 }, { 152,3201 }, { 153,3201 },
 { 154,3201 }, { 155,3201 }, { 156,3201 }, { 157,3201 }, { 158,3201 },
 { 159,3201 }, { 160,3201 }, { 161,3201 }, { 162,3201 }, { 163,3201 },
 { 164,3201 }, { 165,3201 }, { 166,3201 }, { 167,3201 }, { 168,3201 },
 { 169,3201 }, { 170,3201 }, { 171,3201 }, { 172,3201 }, { 173,3201 },
 { 174,3201 }, { 175,3201 }, { 176,3201 }, { 177,3201 }, { 178,3201 },
 { 179,3201 }, { 180,3201 }, { 181,3201 }, { 182,3201 }, { 183,3201 },
 { 184,3201 }, { 185,3201 }, { 186,3201 }, { 187,3201 }, { 188,3201 },

 { 189,3201 }, { 190,3201 }, { 191,3201 }, { 192,3201 }, { 193,3201 },
 { 194,3201 }, { 195,3201 }, { 196,3201 }, { 197,3201 }, { 198,3201 },
 { 199,3201 }, { 200,3201 }, { 201,3201 }, { 202,3201 }, { 203,3201 },
 { 204,3201 }, { 205,3201 }, { 206,3201 }, { 207,3201 }, { 208,3201 },
 { 209,3201 }, { 210,3201 }, { 211,3201 }, { 212,3201 }, { 213,3201 },
 { 214,3201 }, { 215,3201 }, { 216,3201 }, { 217,3201 }, { 218,3201 },
 { 219,3201 }, { 220,3201 }, { 221,3201 }, { 222,3201 }, { 223,3201 },
 { 224,3201 }, { 225,3201 }, { 226,3201 }, { 227,3201 }, { 228,3201 },
 { 229,3201 }, { 230,3201 }, { 231,3201 }, { 232,3201 }, { 233,3201 },
 { 234,3201 }, { 235,3201 }, { 236,3201 }, { 237,3201 }, { 238,3201 },

 { 239,3201 }, { 240,3201 }, { 241,3201 }, { 242,3201 }, { 243,3201 },
 { 244,3201 }, { 245,3201 }, { 246,3201 }, { 247,3201 }, { 248,3201 },
 { 249,3201 }, { 250,3201 }, { 251,3201 }, { 252,3201 }, { 253,3201 },
 { 254,3201 }, { 255,3201 }, { 256,2838 }, {   0,   0 }, {   0,8282 },
 {   1,3200 }, {   2,3200 }, {   3,3200 }, {   4,3200 }, {   5,3200 },
 {   6,3200 }, {   7,3200 }, {   8,3200 }, {   9,3200 }, {  10,3200 },
 {  11,3200 }, {  12,3200 }, {  13,3200 }, {  14,3200 }, {  15,3200 },
 {  16,3200 }, {  17,3200 }, {  18,3200 }, {  19,3200 }, {  20,3200 },
 {  21,3200 }, {  22,3200 }, {  23,3200 }, {  24,3200 }, {  25,3200 },
 {  26,3200 }, {  27,3200 }, {  28,3200 }, {  29,3200 }, {  30,3200 },

 {  31,3200 }, {  32,3200 }, {  33,3200 }, {  34,3200 }, {  35,3200 },
 {  36,3200 }, {  37,3200 }, {  38,3200 }, {  39,3200 }, {  40,3200 },
 {  41,3200 }, {  42,2920 }, {  43,3200 }, {  44,3200 }, {  45,3200 },
 {  46,3200 }, {  47,3200 }, {  48,3200 }, {  49,3200 }, {  50,3200 },
 {  51,3200 }, {  52,3200 }, {  53,3200 }, {  54,3200 }, {  55,3200 },
 {  56,3200 }, {  57,3200 }, {  58,3200 }, {  59,3200 }, {  60,3200 },
 {  61,3200 }, {  62,3200 }, {  63,3200 }, {  64,3200 }, {  65,3200 },
 {  66,3200 }, {  67,3200 }, {  68,3200 }, {  69,3200 }, {  70,3200 },
 {  71,3200 }, {  72,3200 }, {  73,3200 }, {  74,3200 }, {  75,3200 },
 {  76,3200 }, {  77,3200 }, {  78,3200 }, {  79,3200 }, {  80,3200 },

 {  81,3200 }, {  82,3200 }, {  83,3200 }, {  84,3200 }, {  85,3200 },
 {  86,3200 }, {  87,3200 }, {  88,3200 }, {  89,3200 }, {  90,3200 },
 {  91,3200 }, {  92,3200 }, {  93,3200 }, {  94,3200 }, {  95,3200 },
 {  96,3200 }, {  97,3200 }, {  98,3200 }, {  99,3200 }, { 100,3200 },
 { 101,3200 }, { 102,3200 }, { 103,3200 }, { 104,3200 }, { 105,3200 },
 { 106,3200 }, { 107,3200 }, { 108,3200 }, { 109,3200 }, { 110,3200 },
 { 111,3200 }, { 112,3200 }, { 113,3200 }, { 114,3200 }, { 115,3200 },
 { 116,3200 }, { 117,3200 }, { 118,3200 }, { 119,3200 }, { 120,3200 },
 { 121,3200 }, { 122,3200 }, { 123,3200 }, { 124,3200 }, { 125,3200 },
 { 126,3200 }, { 127,3200 }, { 128,3200 }, { 129,3200 }, { 130,3200 },

 { 131,3200 }, { 132,3200 }, { 133,3200 }, { 134,3200 }, { 135,3200 },
 { 136,3200 }, { 137,3200 }, { 138,3200 }, { 139,3200 }, { 140,3200 },
 { 141,3200 }, { 142,3200 }, { 143,3200 }, { 144,3200 }, { 145,3200 },
 { 146,3200 }, { 147,3200 }, { 148,3200 }, { 149,3200 }, { 150,3200 },
 { 151,3200 }, { 152,3200 }, { 153,3200 }, { 154,3200 }, { 155,3200 },
 { 156,3200 }, { 157,3200 }, { 158,3200 }, { 159,3200 }, { 160,3200 },
 { 161,3200 }, { 162,3200 }, { 163,3200 }, { 164,3200 }, { 165,3200 },
 { 166,3200 }, { 167,3200 }, { 168,3200 }, { 169,3200 }, { 170,3200 },
 { 171,3200 }, { 172,3200 }, { 173,3200 }, { 174,3200 }, { 175,3200 },
 { 176,3200 }, { 177,3200 }, { 178,3200 }, { 179,3200 }, { 180,3200 },

 { 181,3200 }, { 182,3200 }, { 183,3200 }, { 184,3200 }, { 185,3200 },
 { 186,3200 }, { 187,3200 }, { 188,3200 }, { 189,3200 }, { 190,3200 },
 { 191,3200 }, { 192,3200 }, { 193,3200 }, { 194,3200 }, { 195,3200 },
 { 196,3200 }, { 197,3200 }, { 198,3200 }, { 199,3200 }, { 200,3200 },
 { 201,3200 }, { 202,3200 }, { 203,3200 }, { 204,3200 }, { 205,3200 },
 { 206,3200 }, { 207,3200 }, { 208,3200 }, { 209,3200 }, { 210,3200 },
 { 211,3200 }, { 212,3200 }, { 213,3200 }, { 214,3200 }, { 215,3200 },
 { 216,3200 }, { 217,3200 }, { 218,3200 }, { 219,3200 }, { 220,3200 },
 { 221,3200 }, { 222,3200 }, { 223,3200 }, { 224,3200 }, { 225,3200 },
 { 226,3200 }, { 227,3200 }, { 228,3200 }, { 229,3200 }, { 230,3200 },

 { 231,3200 }, { 232,3200 }, { 233,3200 }, { 234,3200 }, { 235,3200 },
 { 236,3200 }, { 237,3200 }, { 238,3200 }, { 239,3200 }, { 240,3200 },
 { 241,3200 }, { 242,3200 }, { 243,3200 }, { 244,3200 }, { 245,3200 },
 { 246,3200 }, { 247,3200 }, { 248,3200 }, { 249,3200 }, { 250,3200 },
 { 251,3200 }, { 252,3200 }, { 253,3200 }, { 254,3200 }, { 255,3200 },
 { 256,3200 }, {   0,   0 }, {   0,8024 }, {   1,2942 }, {   2,2942 },
 {   3,2942 }, {   4,2942 }, {   5,2942 }, {   6,2942 }, {   7,2942 },
 {   8,2942 }, {   9,2942 }, {  10,2942 }, {  11,2942 }, {  12,2942 },
 {  13,2942 }, {  14,2942 }, {  15,2942 }, {  16,2942 }, {  17,2942 },
 {  18,2942 }, {  19,2942 }, {  20,2942 }, {  21,2942 }, {  22,2942 },

 {  23,2942 }, {  24,2942 }, {  25,2942 }, {  26,2942 }, {  27,2942 },
 {  28,2942 }, {  29,2942 }, {  30,2942 }, {  31,2942 }, {  32,2942 },
 {  33,2942 }, {  34,2942 }, {  35,2942 }, {  36,2942 }, {  37,2942 },
 {  38,2942 }, {  39,2942 }, {  40,2942 }, {  41,2942 }, {  42,2662 },
 {  43,2942 }, {  44,2942 }, {  45,2942 }, {  46,2942 }, {  47,2942 },
 {  48,2942 }, {  49,2942 }, {  50,2942 }, {  51,2942 }, {  52,2942 },
 {  53,2942 }, {  54,2942 }, {  55,2942 }, {  56,2942 }, {  57,2942 },
 {  58,2942 }, {  59,2942 }, {  60,2942 }, {  61,2942 }, {  62,2942 },
 {  63,2942 }, {  64,2942 }, {  65,2942 }, {  66,2942 }, {  67,2942 },
 {  68,2942 }, {  69,2942 }, {  70,2942 }, {  71,2942 }, {  72,2942 },

 {  73,2942 }, {  74,2942 }, {  75,2942 }, {  76,2942 }, {  77,2942 },
 {  78,2942 }, {  79,2942 }, {  80,2942 }, {  81,2942 }, {  82,2942 },
 {  83,2942 }, {  84,2942 }, {  85,2942 }, {  86,2942 }, {  87,2942 },
 {  88,2942 }, {  89,2942 }, {  90,2942 }, {  91,2942 }, {  92,2942 },
 {  93,2942 }, {  94,2942 }, {  95,2942 }, {  96,2942 }, {  97,2942 },
 {  98,2942 }, {  99,2942 }, { 100,2942 }, { 101,2942 }, { 102,2942 },
 { 103,2942 }, { 104,2942 }, { 105,2942 }, { 106,2942 }, { 107,2942 },
 { 108,2942 }, { 109,2942 }, { 110,2942 }, { 111,2942 }, { 112,2942 },
 { 113,2942 }, { 114,2942 }, { 115,2942 }, { 116,2942 }, { 117,2942 },
 { 118,2942 }, { 119,2942 }, { 120,2942 }, { 121,2942 }, { 122,2942 },

 { 123,2942 }, { 124,2942 }, { 125,2942 }, { 126,2942 }, { 127,2942 },
 { 128,2942 }, { 129,2942 }, { 130,2942 }, { 131,2942 }, { 132,2942 },
 { 133,2942 }, { 134,2942 }, { 135,2942 }, { 136,2942 }, { 137,2942 },
 { 138,2942 }, { 139,2942 }, { 140,2942 }, { 141,2942 }, { 142,2942 },
 { 143,2942 }, { 144,2942 }, { 145,2942 }, { 146,2942 }, { 147,2942 },
 { 148,2942 }, { 149,2942 }, { 150,2942 }, { 151,2942 }, { 152,2942 },
 { 153,2942 }, { 154,2942 }, { 155,2942 }, { 156,2942 }, { 157,2942 },
 { 158,2942 }, { 159,2942 }, { 160,2942 }, { 161,2942 }, { 162,2942 },
 { 163,2942 }, { 164,2942 }, { 165,2942 }, { 166,2942 }, { 167,2942 },
 { 168,2942 }, { 169,2942 }, { 170,2942 }, { 171,2942 }, { 172,2942 },

 { 173,2942 }, { 174,2942 }, { 175,2942 }, { 176,2942 }, { 177,2942 },
 { 178,2942 }, { 179,2942 }, { 180,2942 }, { 181,2942 }, { 182,2942 },
 { 183,2942 }, { 184,2942 }, { 185,2942 }, { 186,2942 }, { 187,2942 },
 { 188,2942 }, { 189,2942 }, { 190,2942 }, { 191,2942 }, { 192,2942 },
 { 193,2942 }, { 194,2942 }, { 195,2942 }, { 196,2942 }, { 197,2942 },
 { 198,2942 }, { 199,2942 }, { 200,2942 }, { 201,2942 }, { 202,2942 },
 { 203,2942 }, { 204,2942 }, { 205,2942 }, { 206,2942 }, { 207,2942 },
 { 208,2942 }, { 209,2942 }, { 210,2942 }, { 211,2942 }, { 212,2942 },
 { 213,2942 }, { 214,2942 }, { 215,2942 }, { 216,2942 }, { 217,2942 },
 { 218,2942 }, { 219,2942 }, { 220,2942 }, { 221,2942 }, { 222,2942 },

 { 223,2942 }, { 224,2942 }, { 225,2942 }, { 226,2942 }, { 227,2942 },
 { 228,2942 }, { 229,2942 }, { 230,2942 }, { 231,2942 }, { 232,2942 },
 { 233,2942 }, { 234,2942 }, { 235,2942 }, { 236,2942 }, { 237,2942 },
 { 238,2942 }, { 239,2942 }, { 240,2942 }, { 241,2942 }, { 242,2942 },
 { 243,2942 }, { 244,2942 }, { 245,2942 }, { 246,2942 }, { 247,2942 },
 { 248,2942 }, { 249,2942 }, { 250,2942 }, { 251,2942 }, { 252,2942 },
 { 253,2942 }, { 254,2942 }, { 255,2942 }, { 256,2942 }, {   0,   0 },
 {   0,7766 }, {   1,2942 }, {   2,2942 }, {   3,2942 }, {   4,2942 },
 {   5,2942 }, {   6,2942 }, {   7,2942 }, {   8,2942 }, {   9,2942 },
 {  10,2942 }, {  11,2942 }, {  12,2942 }, {  13,2942 }, {  14,2942 },

 {  15,2942 }, {  16,2942 }, {  17,2942 }, {  18,2942 }, {  19,2942 },
 {  20,2942 }, {  21,2942 }, {  22,2942 }, {  23,2942 }, {  24,2942 },
 {  25,2942 }, {  26,2942 }, {  27,2942 }, {  28,2942 }, {  29,2942 },
 {  30,2942 }, {  31,2942 }, {  32,2942 }, {  33,2942 }, {  34,2406 },
 {  35,2942 }, {  36,2942 }, {  37,2942 }, {  38,2942 }, {  39,2942 },
 {  40,2942 }, {  41,2942 }, {  42,2942 }, {  43,2942 }, {  44,2942 },
 {  45,2942 }, {  46,2942 }, {  47,2942 }, {  48,2942 }, {  49,2942 },
 {  50,2942 }, {  51,2942 }, {  52,2942 }, {  53,2942 }, {  54,2942 },
 {  55,2942 }, {  56,2942 }, {  57,2942 }, {  58,2942 }, {  59,2942 },
 {  60,2942 }, {  61,2942 }, {  62,2942 }, {  63,2942 }, {  64,2942 },

 {  65,2942 }, {  66,2942 }, {  67,2942 }, {  68,2942 }, {  69,2942 },
 {  70,2942 }, {  71,2942 }, {  72,2942 }, {  73,2942 }, {  74,2942 },
 {  75,2942 }, {  76,2942 }, {  77,2942 }, {  78,2942 }, {  79,2942 },
 {  80,2942 }, {  81,2942 }, {  82,2942 }, {  83,2942 }, {  84,2942 },
 {  85,2942 }, {  86,2942 }, {  87,2942 }, {  88,2942 }, {  89,2942 },
 {  90,2942 }, {  91,2942 }, {  92,3200 }, {  93,2942 }, {  94,2942 },
 {  95,2942 }, {  96,2942 }, {  97,2942 }, {  98,2942 }, {  99,2942 },
 { 100,2942 }, { 101,2942 }, { 102,2942 }, { 103,2942 }, { 104,2942 },
 { 105,2942 }, { 106,2942 }, { 107,2942 }, { 108,2942 }, { 109,2942 },
 { 110,2942 }, { 111,2942 }, { 112,2942 }, { 113,2942 }, { 114,2942 },

 { 115,2942 }, { 116,2942 }, { 117,2942 }, { 118,2942 }, { 119,2942 },
 { 120,2942 }, { 121,2942 }, { 122,2942 }, { 123,2942 }, { 124,2942 },
 { 125,2942 }, { 126,2942 }, { 127,2942 }, { 128,2942 }, { 129,2942 },
 { 130,2942 }, { 131,2942 }, { 132,2942 }, { 133,2942 }, { 134,2942 },
 { 135,2942 }, { 136,2942 }, { 137,2942 }, { 138,2942 }, { 139,2942 },
 { 140,2942 }, { 141,2942 }, { 142,2942 }, { 143,2942 }, { 144,2942 },
 { 145,2942 }, { 146,2942 }, { 147,2942 }, { 148,2942 }, { 149,2942 },
 { 150,2942 }, { 151,2942 }, { 152,2942 }, { 153,2942 }, { 154,2942 },
 { 155,2942 }, { 156,2942 }, { 157,2942 }, { 158,2942 }, { 159,2942 },
 { 160,2942 }, { 161,2942 }, { 162,2942 }, { 163,2942 }, { 164,2942 },

 { 165,2942 }, { 166,2942 }, { 167,2942 }, { 168,2942 }, { 169,2942 },
 { 170,2942 }, { 171,2942 }, { 172,2942 }, { 173,2942 }, { 174,2942 },
 { 175,2942 }, { 176,2942 }, { 177,2942 }, { 178,2942 }, { 179,2942 },
 { 180,2942 }, { 181,2942 }, { 182,2942 }, { 183,2942 }, { 184,2942 },
 { 185,2942 }, { 186,2942 }, { 187,2942 }, { 188,2942 }, { 189,2942 },
 { 190,2942 }, { 191,2942 }, { 192,2942 }, { 193,2942 }, { 194,2942 },
 { 195,2942 }, { 196,2942 }, { 197,2942 }, { 198,2942 }, { 199,2942 },
 { 200,2942 }, { 201,2942 }, { 202,2942 }, { 203,2942 }, { 204,2942 },
 { 205,2942 }, { 206,2942 }, { 207,2942 }, { 208,2942 }, { 209,2942 },
 { 210,2942 }, { 211,2942 }, { 212,2942 }, { 213,2942 }, { 214,2942 },

 { 215,2942 }, { 216,2942 }, { 217,2942 }, { 218,2942 }, { 219,2942 },
 { 220,2942 }, { 221,2942 }, { 222,2942 }, { 223,2942 }, { 224,2942 },
 { 225,2942 }, { 226,2942 }, { 227,2942 }, { 228,2942 }, { 229,2942 },
 { 230,2942 }, { 231,2942 }, { 232,2942 }, { 233,2942 }, { 234,2942 },
 { 235,2942 }, { 236,2942 }, { 237,2942 }, { 238,2942 }, { 239,2942 },
 { 240,2942 }, { 241,2942 }, { 242,2942 }, { 243,2942 }, { 244,2942 },
 { 245,2942 }, { 246,2942 }, { 247,2942 }, { 248,2942 }, { 249,2942 },
 { 250,2942 }, { 251,2942 }, { 252,2942 }, { 253,2942 }, { 254,2942 },
 { 255,2942 }, { 256,2942 }, {   0,   0 }, {   0,7508 }, {   1,2684 },
 {   2,2684 }, {   3,2684 }, {   4,2684 }, {   5,2684 }, {   6,2684 },

 {   7,2684 }, {   8,2684 }, {   9,2684 }, {  10,2684 }, {  11,2684 },
 {  12,2684 }, {  13,2684 }, {  14,2684 }, {  15,2684 }, {  16,2684 },
 {  17,2684 }, {  18,2684 }, {  19,2684 }, {  20,2684 }, {  21,2684 },
 {  22,2684 }, {  23,2684 }, {  24,2684 }, {  25,2684 }, {  26,2684 },
 {  27,2684 }, {  28,2684 }, {  29,2684 }, {  30,2684 }, {  31,2684 },
 {  32,2684 }, {  33,2684 }, {  34,2148 }, {  35,2684 }, {  36,2684 },
 {  37,2684 }, {  38,2684 }, {  39,2684 }, {  40,2684 }, {  41,2684 },
 {  42,2684 }, {  43,2684 }, {  44,2684 }, {  45,2684 }, {  46,2684 },
 {  47,2684 }, {  48,2684 }, {  49,2684 }, {  50,2684 }, {  51,2684 },
 {  52,2684 }, {  53,2684 }, {  54,2684 }, {  55,2684 }, {  56,2684 },

 {  57,2684 }, {  58,2684 }, {  59,2684 }, {  60,2684 }, {  61,2684 },
 {  62,2684 }, {  63,2684 }, {  64,2684 }, {  65,2684 }, {  66,2684 },
 {  67,2684 }, {  68,2684 }, {  69,2684 }, {  70,2684 }, {  71,2684 },
 {  72,2684 }, {  73,2684 }, {  74,2684 }, {  75,2684 }, {  76,2684 },
 {  77,2684 }, {  78,2684 }, {  79,2684 }, {  80,2684 }, {  81,2684 },
 {  82,2684 }, {  83,2684 }, {  84,2684 }, {  85,2684 }, {  86,2684 },
 {  87,2684 }, {  88,2684 }, {  89,2684 }, {  90,2684 }, {  91,2684 },
 {  92,2942 }, {  93,2684 }, {  94,2684 }, {  95,2684 }, {  96,2684 },
 {  97,2684 }, {  98,2684 }, {  99,2684 }, { 100,2684 }, { 101,2684 },
 { 102,2684 }, { 103,2684 }, { 104,2684 }, { 105,2684 }, { 106,2684 },

 { 107,2684 }, { 108,2684 }, { 109,2684 }, { 110,2684 }, { 111,2684 },
 { 112,2684 }, { 113,2684 }, { 114,2684 }, { 115,2684 }, { 116,2684 },
 { 117,2684 }, { 118,2684 }, { 119,2684 }, { 120,2684 }, { 121,2684 },
 { 122,2684 }, { 123,2684 }, { 124,2684 }, { 125,2684 }, { 126,2684 },
 { 127,2684 }, { 128,2684 }, { 129,2684 }, { 130,2684 }, { 131,2684 },
 { 132,2684 }, { 133,2684 }, { 134,2684 }, { 135,2684 }, { 136,2684 },
 { 137,2684 }, { 138,2684 }, { 139,2684 }, { 140,2684 }, { 141,2684 },
 { 142,2684 }, { 143,2684 }, { 144,2684 }, { 145,2684 }, { 146,2684 },
 { 147,2684 }, { 148,2684 }, { 149,2684 }, { 150,2684 }, { 151,2684 },
 { 152,2684 }, { 153,2684 }, { 154,2684 }, { 155,2684 }, { 156,2684 },

 { 157,2684 }, { 158,2684 }, { 159,2684 }, { 160,2684 }, { 161,2684 },
 { 162,2684 }, { 163,2684 }, { 164,2684 }, { 165,2684 }, { 166,2684 },
 { 167,2684 }, { 168,2684 }, { 169,2684 }, { 170,2684 }, { 171,2684 },
 { 172,2684 }, { 173,2684 }, { 174,2684 }, { 175,2684 }, { 176,2684 },
 { 177,2684 }, { 178,2684 }, { 179,2684 }, { 180,2684 }, { 181,2684 },
 { 182,2684 }, { 183,2684 }, { 184,2684 }, { 185,2684 }, { 186,2684 },
 { 187,2684 }, { 188,2684 }, { 189,2684 }, { 190,2684 }, { 191,2684 },
 { 192,2684 }, { 193,2684 }, { 194,2684 }, { 195,2684 }, { 196,2684 },
 { 197,2684 }, { 198,2684 }, { 199,2684 }, { 200,2684 }, { 201,2684 },
 { 202,2684 }, { 203,2684 }, { 204,2684 }, { 205,2684 }, { 206,2684 },

 { 207,2684 }, { 208,2684 }, { 209,2684 }, { 210,2684 }, { 211,2684 },
 { 212,2684 }, { 213,2684 }, { 214,2684 }, { 215,2684 }, { 216,2684 },
 { 217,2684 }, { 218,2684 }, { 219,2684 }, { 220,2684 }, { 221,2684 },
 { 222,2684 }, { 223,2684 }, { 224,2684 }, { 225,2684 }, { 226,2684 },
 { 227,2684 }, { 228,2684 }, { 229,2684 }, { 230,2684 }, { 231,2684 },
 { 232,2684 }, { 233,2684 }, { 234,2684 }, { 235,2684 }, { 236,2684 },
 { 237,2684 }, { 238,2684 }, { 239,2684 }, { 240,2684 }, { 241,2684 },
 { 242,2684 }, { 243,2684 }, { 244,2684 }, { 245,2684 }, { 246,2684 },
 { 247,2684 }, { 248,2684 }, { 249,2684 }, { 250,2684 }, { 251,2684 },
 { 252,2684 }, { 253,2684 }, { 254,2684 }, { 255,2684 }, { 256,2684 },

 {   0,   0 }, {   0,7250 }, {   1,2942 }, {   2,2942 }, {   3,2942 },
 {   4,2942 }, {   5,2942 }, {   6,2942 }, {   7,2942 }, {   8,2942 },
 {   9,2942 }, {  10,2942 }, {  11,2942 }, {  12,2942 }, {  13,2942 },
 {  14,2942 }, {  15,2942 }, {  16,2942 }, {  17,2942 }, {  18,2942 },
 {  19,2942 }, {  20,2942 }, {  21,2942 }, {  22,2942 }, {  23,2942 },
 {  24,2942 }, {  25,2942 }, {  26,2942 }, {  27,2942 }, {  28,2942 },
 {  29,2942 }, {  30,2942 }, {  31,2942 }, {  32,2942 }, {  33,2942 },
 {  34,2942 }, {  35,2942 }, {  36,2942 }, {  37,2942 }, {  38,2942 },
 {  39,1908 }, {  40,2942 }, {  41,2942 }, {  42,2942 }, {  43,2942 },
 {  44,2942 }, {  45,2942 }, {  46,2942 }, {  47,2942 }, {  48,2942 },

 {  49,2942 }, {  50,2942 }, {  51,2942 }, {  52,2942 }, {  53,2942 },
 {  54,2942 }, {  55,2942 }, {  56,2942 }, {  57,2942 }, {  58,2942 },
 {  59,2942 }, {  60,2942 }, {  61,2942 }, {  62,2942 }, {  63,2942 },
 {  64,2942 }, {  65,2942 }, {  66,2942 }, {  67,2942 }, {  68,2942 },
 {  69,2942 }, {  70,2942 }, {  71,2942 }, {  72,2942 }, {  73,2942 },
 {  74,2942 }, {  75,2942 }, {  76,2942 }, {  77,2942 }, {  78,2942 },
 {  79,2942 }, {  80,2942 }, {  81,2942 }, {  82,2942 }, {  83,2942 },
 {  84,2942 }, {  85,2942 }, {  86,2942 }, {  87,2942 }, {  88,2942 },
 {  89,2942 }, {  90,2942 }, {  91,2942 }, {  92,2684 }, {  93,2942 },
 {  94,2942 }, {  95,2942 }, {  96,2942 }, {  97,2942 }, {  98,2942 },

 {  99,2942 }, { 100,2942 }, { 101,2942 }, { 102,2942 }, { 103,2942 },
 { 104,2942 }, { 105,2942 }, { 106,2942 }, { 107,2942 }, { 108,2942 },
 { 109,2942 }, { 110,2942 }, { 111,2942 }, { 112,2942 }, { 113,2942 },
 { 114,2942 }, { 115,2942 }, { 116,2942 }, { 117,2942 }, { 118,2942 },
 { 119,2942 }, { 120,2942 }, { 121,2942 }, { 122,2942 }, { 123,2942 },
 { 124,2942 }, { 125,2942 }, { 126,2942 }, { 127,2942 }, { 128,2942 },
 { 129,2942 }, { 130,2942 }, { 131,2942 }, { 132,2942 }, { 133,2942 },
 { 134,2942 }, { 135,2942 }, { 136,2942 }, { 137,2942 }, { 138,2942 },
 { 139,2942 }, { 140,2942 }, { 141,2942 }, { 142,2942 }, { 143,2942 },
 { 144,2942 }, { 145,2942 }, { 146,2942 }, { 147,2942 }, { 148,2942 },

 { 149,2942 }, { 150,2942 }, { 151,2942 }, { 152,2942 }, { 153,2942 },
 { 154,2942 }, { 155,2942 }, { 156,2942 }, { 157,2942 }, { 158,2942 },
 { 159,2942 }, { 160,2942 }, { 161,2942 }, { 162,2942 }, { 163,2942 },
 { 164,2942 }, { 165,2942 }, { 166,2942 }, { 167,2942 }, { 168,2942 },
 { 169,2942 }, { 170,2942 }, { 171,2942 }, { 172,2942 }, { 173,2942 },
 { 174,2942 }, { 175,2942 }, { 176,2942 }, { 177,2942 }, { 178,2942 },
 { 179,2942 }, { 180,2942 }, { 181,2942 }, { 182,2942 }, { 183,2942 },
 { 184,2942 }, { 185,2942 }, { 186,2942 }, { 187,2942 }, { 188,2942 },
 { 189,2942 }, { 190,2942 }, { 191,2942 }, { 192,2942 }, { 193,2942 },
 { 194,2942 }, { 195,2942 }, { 196,2942 }, { 197,2942 }, { 198,2942 },

 { 199,2942 }, { 200,2942 }, { 201,2942 }, { 202,2942 }, { 203,2942 },
 { 204,2942 }, { 205,2942 }, { 206,2942 }, { 207,2942 }, { 208,2942 },
 { 209,2942 }, { 210,2942 }, { 211,2942 }, { 212,2942 }, { 213,2942 },
 { 214,2942 }, { 215,2942 }, { 216,2942 }, { 217,2942 }, { 218,2942 },
 { 219,2942 }, { 220,2942 }, { 221,2942 }, { 222,2942 }, { 223,2942 },
 { 224,2942 }, { 225,2942 }, { 226,2942 }, { 227,2942 }, { 228,2942 },
 { 229,2942 }, { 230,2942 }, { 231,2942 }, { 232,2942 }, { 233,2942 },
 { 234,2942 }, { 235,2942 }, { 236,2942 }, { 237,2942 }, { 238,2942 },
 { 239,2942 }, { 240,2942 }, { 241,2942 }, { 242,2942 }, { 243,2942 },
 { 244,2942 }, { 245,2942 }, { 246,2942 }, { 247,2942 }, { 248,2942 },

 { 249,2942 }, { 250,2942 }, { 251,2942 }, { 252,2942 }, { 253,2942 },
 { 254,2942 }, { 255,2942 }, { 256,2942 }, {   0,   0 }, {   0,6992 },
 {   1,2684 }, {   2,2684 }, {   3,2684 }, {   4,2684 }, {   5,2684 },
 {   6,2684 }, {   7,2684 }, {   8,2684 }, {   9,2684 }, {  10,2684 },
 {  11,2684 }, {  12,2684 }, {  13,2684 }, {  14,2684 }, {  15,2684 },
 {  16,2684 }, {  17,2684 }, {  18,2684 }, {  19,2684 }, {  20,2684 },
 {  21,2684 }, {  22,2684 }, {  23,2684 }, {  24,2684 }, {  25,2684 },
 {  26,2684 }, {  27,2684 }, {  28,2684 }, {  29,2684 }, {  30,2684 },
 {  31,2684 }, {  32,2684 }, {  33,2684 }, {  34,2684 }, {  35,2684 },
 {  36,2684 }, {  37,2684 }, {  38,2684 }, {  39,1650 }, {  40,2684 },

 {  41,2684 }, {  42,2684 }, {  43,2684 }, {  44,2684 }, {  45,2684 },
 {  46,2684 }, {  47,2684 }, {  48,2684 }, {  49,2684 }, {  50,2684 },
 {  51,2684 }, {  52,2684 }, {  53,2684 }, {  54,2684 }, {  55,2684 },
 {  56,2684 }, {  57,2684 }, {  58,2684 }, {  59,2684 }, {  60,2684 },
 {  61,2684 }, {  62,2684 }, {  63,2684 }, {  64,2684 }, {  65,2684 },
 {  66,2684 }, {  67,2684 }, {  68,2684 }, {  69,2684 }, {  70,2684 },
 {  71,2684 }, {  72,2684 }, {  73,2684 }, {  74,2684 }, {  75,2684 },
 {  76,2684 }, {  77,2684 }, {  78,2684 }, {  79,2684 }, {  80,2684 },
 {  81,2684 }, {  82,2684 }, {  83,2684 }, {  84,2684 }, {  85,2684 },
 {  86,2684 }, {  87,2684 }, {  88,2684 }, {  89,2684 }, {  90,2684 },

 {  91,2684 }, {  92,2426 }, {  93,2684 }, {  94,2684 }, {  95,2684 },
 {  96,2684 }, {  97,2684 }, {  98,2684 }, {  99,2684 }, { 100,2684 },
 { 101,2684 }, { 102,2684 }, { 103,2684 }, { 104,2684 }, { 105,2684 },
 { 106,2684 }, { 107,2684 }, { 108,2684 }, { 109,2684 }, { 110,2684 },
 { 111,2684 }, { 112,2684 }, { 113,2684 }, { 114,2684 }, { 115,2684 },
 { 116,2684 }, { 117,2684 }, { 118,2684 }, { 119,2684 }, { 120,2684 },
 { 121,2684 }, { 122,2684 }, { 123,2684 }, { 124,2684 }, { 125,2684 },
 { 126,2684 }, { 127,2684 }, { 128,2684 }, { 129,2684 }, { 130,2684 },
 { 131,2684 }, { 132,2684 }, { 133,2684 }, { 134,2684 }, { 135,2684 },
 { 136,2684 }, { 137,2684 }, { 138,2684 }, { 139,2684 }, { 140,2684 },

 { 141,2684 }, { 142,2684 }, { 143,2684 }, { 144,2684 }, { 145,2684 },
 { 146,2684 }, { 147,2684 }, { 148,2684 }, { 149,2684 }, { 150,2684 },
 { 151,2684 }, { 152,2684 }, { 153,2684 }, { 154,2684 }, { 155,2684 },
 { 156,2684 }, { 157,2684 }, { 158,2684 }, { 159,2684 }, { 160,2684 },
 { 161,2684 }, { 162,2684 }, { 163,2684 }, { 164,2684 }, { 165,2684 },
 { 166,2684 }, { 167,2684 }, { 168,2684 }, { 169,2684 }, { 170,2684 },
 { 171,2684 }, { 172,2684 }, { 173,2684 }, { 174,2684 }, { 175,2684 },
 { 176,2684 }, { 177,2684 }, { 178,2684 }, { 179,2684 }, { 180,2684 },
 { 181,2684 }, { 182,2684 }, { 183,2684 }, { 184,2684 }, { 185,2684 },
 { 186,2684 }, { 187,2684 }, { 188,2684 }, { 189,2684 }, { 190,2684 },

 { 191,2684 }, { 192,2684 }, { 193,2684 }, { 194,2684 }, { 195,2684 },
 { 196,2684 }, { 197,2684 }, { 198,2684 }, { 199,2684 }, { 200,2684 },
 { 201,2684 }, { 202,2684 }, { 203,2684 }, { 204,2684 }, { 205,2684 },
 { 206,2684 }, { 207,2684 }, { 208,2684 }, { 209,2684 }, { 210,2684 },
 { 211,2684 }, { 212,2684 }, { 213,2684 }, { 214,2684 }, { 215,2684 },
 { 216,2684 }, { 217,2684 }, { 218,2684 }, { 219,2684 }, { 220,2684 },
 { 221,2684 }, { 222,2684 }, { 223,2684 }, { 224,2684 }, { 225,2684 },
 { 226,2684 }, { 227,2684 }, { 228,2684 }, { 229,2684 }, { 230,2684 },
 { 231,2684 }, { 232,2684 }, { 233,2684 }, { 234,2684 }, { 235,2684 },
 { 236,2684 }, { 237,2684 }, { 238,2684 }, { 239,2684 }, { 240,2684 },

 { 241,2684 }, { 242,2684 }, { 243,2684 }, { 244,2684 }, { 245,2684 },
 { 246,2684 }, { 247,2684 }, { 248,2684 }, { 249,2684 }, { 250,2684 },
 { 251,2684 }, { 252,2684 }, { 253,2684 }, { 254,2684 }, { 255,2684 },
 { 256,2684 }, {   0,   0 }, {   0,6734 }, {   1,1397 }, {   2,1397 },
 {   3,1397 }, {   4,1397 }, {   5,1397 }, {   6,1397 }, {   7,1397 },
 {   8,1397 }, {   9,1397 }, {  10,1397 }, {  11,1397 }, {  12,1397 },
 {  13,1397 }, {  14,1397 }, {  15,1397 }, {  16,1397 }, {  17,1397 },
 {  18,1397 }, {  19,1397 }, {  20,1397 }, {  21,1397 }, {  22,1397 },
 {  23,1397 }, {  24,1397 }, {  25,1397 }, {  26,1397 }, {  27,1397 },
 {  28,1397 }, {  29,1397 }, {  30,1397 }, {  31,1397 }, {  32,1397 },

 {  33,1397 }, {  34,1397 }, {  35,1397 }, {  36,1397 }, {  37,1397 },
 {  38,1397 }, {  39,1397 }, {  40,1397 }, {  41,1397 }, {  42,1397 },
 {  43,1397 }, {  44,1397 }, {  45,1397 }, {  46,1397 }, {  47,1397 },
 {  48,1397 }, {  49,1397 }, {  50,1397 }, {  51,1397 }, {  52,1397 },
 {  53,1397 }, {  54,1397 }, {  55,1397 }, {  56,1397 }, {  57,1397 },
 {  58,1397 }, {  59,1397 }, {  60,1397 }, {  61,1397 }, {  62,1397 },
 {  63,1397 }, {  64,1397 }, {  65,1397 }, {  66,1397 }, {  67,1397 },
 {  68,1397 }, {  69,1397 }, {  70,1397 }, {  71,1397 }, {  72,1397 },
 {  73,1397 }, {  74,1397 }, {  75,1397 }, {  76,1397 }, {  77,1397 },
 {  78,1397 }, {  79,1397 }, {  80,1397 }, {  81,1397 }, {  82,1397 },

 {  83,1397 }, {  84,1397 }, {  85,1397 }, {  86,1397 }, {  87,1397 },
 {  88,1397 }, {  89,1397 }, {  90,1397 }, {  91,1397 }, {  92,1403 },
 {  93,1397 }, {  94,1397 }, {  95,1397 }, {  96,1397 }, {  97,1397 },
 {  98,1397 }, {  99,1397 }, { 100,1397 }, { 101,1397 }, { 102,1397 },
 { 103,1397 }, { 104,1397 }, { 105,1397 }, { 106,1397 }, { 107,1397 },
 { 108,1397 }, { 109,1397 }, { 110,1397 }, { 111,1397 }, { 112,1397 },
 { 113,1397 }, { 114,1397 }, { 115,1397 }, { 116,1397 }, { 117,1397 },
 { 118,1397 }, { 119,1397 }, { 120,1397 }, { 121,1397 }, { 122,1397 },
 { 123,1397 }, { 124,1397 }, { 125,1397 }, { 126,1397 }, { 127,1397 },
 { 128,1397 }, { 129,1397 }, { 130,1397 }, { 131,1397 }, { 132,1397 },

 { 133,1397 }, { 134,1397 }, { 135,1397 }, { 136,1397 }, { 137,1397 },
 { 138,1397 }, { 139,1397 }, { 140,1397 }, { 141,1397 }, { 142,1397 },
 { 143,1397 }, { 144,1397 }, { 145,1397 }, { 146,1397 }, { 147,1397 },
 { 148,1397 }, { 149,1397 }, { 150,1397 }, { 151,1397 }, { 152,1397 },
 { 153,1397 }, { 154,1397 }, { 155,1397 }, { 156,1397 }, { 157,1397 },
 { 158,1397 }, { 159,1397 }, { 160,1397 }, { 161,1397 }, { 162,1397 },
 { 163,1397 }, { 164,1397 }, { 165,1397 }, { 166,1397 }, { 167,1397 },
 { 168,1397 }, { 169,1397 }, { 170,1397 }, { 171,1397 }, { 172,1397 },
 { 173,1397 }, { 174,1397 }, { 175,1397 }, { 176,1397 }, { 177,1397 },
 { 178,1397 }, { 179,1397 }, { 180,1397 }, { 181,1397 }, { 182,1397 },

 { 183,1397 }, { 184,1397 }, { 185,1397 }, { 186,1397 }, { 187,1397 },
 { 188,1397 }, { 189,1397 }, { 190,1397 }, { 191,1397 }, { 192,1397 },
 { 193,1397 }, { 194,1397 }, { 195,1397 }, { 196,1397 }, { 197,1397 },
 { 198,1397 }, { 199,1397 }, { 200,1397 }, { 201,1397 }, { 202,1397 },
 { 203,1397 }, { 204,1397 }, { 205,1397 }, { 206,1397 }, { 207,1397 },
 { 208,1397 }, { 209,1397 }, { 210,1397 }, { 211,1397 }, { 212,1397 },
 { 213,1397 }, { 214,1397 }, { 215,1397 }, { 216,1397 }, { 217,1397 },
 { 218,1397 }, { 219,1397 }, { 220,1397 }, { 221,1397 }, { 222,1397 },
 { 223,1397 }, { 224,1397 }, { 225,1397 }, { 226,1397 }, { 227,1397 },
 { 228,1397 }, { 229,1397 }, { 230,1397 }, { 231,1397 }, { 232,1397 },

 { 233,1397 }, { 234,1397 }, { 235,1397 }, { 236,1397 }, { 237,1397 },
 { 238,1397 }, { 239,1397 }, { 240,1397 }, { 241,1397 }, { 242,1397 },
 { 243,1397 }, { 244,1397 }, { 245,1397 }, { 246,1397 }, { 247,1397 },
 { 248,1397 }, { 249,1397 }, { 250,1397 }, { 251,1397 }, { 252,1397 },
 { 253,1397 }, { 254,1397 }, { 255,1397 }, { 256,1397 }, {   0,   0 },
 {   0,6476 }, {   1,1139 }, {   2,1139 }, {   3,1139 }, {   4,1139 },
 {   5,1139 }, {   6,1139 }, {   7,1139 }, {   8,1139 }, {   9,1139 },
 {  10,1139 }, {  11,1139 }, {  12,1139 }, {  13,1139 }, {  14,1139 },
 {  15,1139 }, {  16,1139 }, {  17,1139 }, {  18,1139 }, {  19,1139 },
 {  20,1139 }, {  21,1139 }, {  22,1139 }, {  23,1139 }, {  24,1139 },

 {  25,1139 }, {  26,1139 }, {  27,1139 }, {  28,1139 }, {  29,1139 },
 {  30,1139 }, {  31,1139 }, {  32,1139 }, {  33,1139 }, {  34,1139 },
 {  35,1139 }, {  36,1139 }, {  37,1139 }, {  38,1139 }, {  39,1139 },
 {  40,1139 }, {  41,1139 }, {  42,1139 }, {  43,1139 }, {  44,1139 },
 {  45,1139 }, {  46,1139 }, {  47,1139 }, {  48,1139 }, {  49,1139 },
 {  50,1139 }, {  51,1139 }, {  52,1139 }, {  53,1139 }, {  54,1139 },
 {  55,1139 }, {  56,1139 }, {  57,1139 }, {  58,1139 }, {  59,1139 },
 {  60,1139 }, {  61,1139 }, {  62,1139 }, {  63,1139 }, {  64,1139 },
 {  65,1139 }, {  66,1139 }, {  67,1139 }, {  68,1139 }, {  69,1139 },
 {  70,1139 }, {  71,1139 }, {  72,1139 }, {  73,1139 }, {  74,1139 },

 {  75,1139 }, {  76,1139 }, {  77,1139 }, {  78,1139 }, {  79,1139 },
 {  80,1139 }, {  81,1139 }, {  82,1139 }, {  83,1139 }, {  84,1139 },
 {  85,1139 }, {  86,1139 }, {  87,1139 }, {  88,1139 }, {  89,1139 },
 {  90,1139 }, {  91,1139 }, {  92,1145 }, {  93,1139 }, {  94,1139 },
 {  95,1139 }, {  96,1139 }, {  97,1139 }, {  98,1139 }, {  99,1139 },
 { 100,1139 }, { 101,1139 }, { 102,1139 }, { 103,1139 }, { 104,1139 },
 { 105,1139 }, { 106,1139 }, { 107,1139 }, { 108,1139 }, { 109,1139 },
 { 110,1139 }, { 111,1139 }, { 112,1139 }, { 113,1139 }, { 114,1139 },
 { 115,1139 }, { 116,1139 }, { 117,1139 }, { 118,1139 }, { 119,1139 },
 { 120,1139 }, { 121,1139 }, { 122,1139 }, { 123,1139 }, { 124,1139 },

 { 125,1139 }, { 126,1139 }, { 127,1139 }, { 128,1139 }, { 129,1139 },
 { 130,1139 }, { 131,1139 }, { 132,1139 }, { 133,1139 }, { 134,1139 },
 { 135,1139 }, { 136,1139 }, { 137,1139 }, { 138,1139 }, { 139,1139 },
 { 140,1139 }, { 141,1139 }, { 142,1139 }, { 143,1139 }, { 144,1139 },
 { 145,1139 }, { 146,1139 }, { 147,1139 }, { 148,1139 }, { 149,1139 },
 { 150,1139 }, { 151,1139 }, { 152,1139 }, { 153,1139 }, { 154,1139 },
 { 155,1139 }, { 156,1139 }, { 157,1139 }, { 158,1139 }, { 159,1139 },
 { 160,1139 }, { 161,1139 }, { 162,1139 }, { 163,1139 }, { 164,1139 },
 { 165,1139 }, { 166,1139 }, { 167,1139 }, { 168,1139 }, { 169,1139 },
 { 170,1139 }, { 171,1139 }, { 172,1139 }, { 173,1139 }, { 174,1139 },

 { 175,1139 }, { 176,1139 }, { 177,1139 }, { 178,1139 }, { 179,1139 },
 { 180,1139 }, { 181,1139 }, { 182,1139 }, { 183,1139 }, { 184,1139 },
 { 185,1139 }, { 186,1139 }, { 187,1139 }, { 188,1139 }, { 189,1139 },
 { 190,1139 }, { 191,1139 }, { 192,1139 }, { 193,1139 }, { 194,1139 },
 { 195,1139 }, { 196,1139 }, { 197,1139 }, { 198,1139 }, { 199,1139 },
 { 200,1139 }, { 201,1139 }, { 202,1139 }, { 203,1139 }, { 204,1139 },
 { 205,1139 }, { 206,1139 }, { 207,1139 }, { 208,1139 }, { 209,1139 },
 { 210,1139 }, { 211,1139 }, { 212,1139 }, { 213,1139 }, { 214,1139 },
 { 215,1139 }, { 216,1139 }, { 217,1139 }, { 218,1139 }, { 219,1139 },
 { 220,1139 }, { 221,1139 }, { 222,1139 }, { 223,1139 }, { 224,1139 },

 { 225,1139 }, { 226,1139 }, { 227,1139 }, { 228,1139 }, { 229,1139 },
 { 230,1139 }, { 231,1139 }, { 232,1139 }, { 233,1139 }, { 234,1139 },
 { 235,1139 }, { 236,1139 }, { 237,1139 }, { 238,1139 }, { 239,1139 },
 { 240,1139 }, { 241,1139 }, { 242,1139 }, { 243,1139 }, { 244,1139 },
 { 245,1139 }, { 246,1139 }, { 247,1139 }, { 248,1139 }, { 249,1139 },
 { 250,1139 }, { 251,1139 }, { 252,1139 }, { 253,1139 }, { 254,1139 },
 { 255,1139 }, { 256,1139 }, {   0,   0 }, {   0,6218 }, {   1,2168 },
 {   2,2168 }, {   3,2168 }, {   4,2168 }, {   5,2168 }, {   6,2168 },
 {   7,2168 }, {   8,2168 }, {   9,2168 }, {  10,2168 }, {  11,2168 },
 {  12,2168 }, {  13,2168 }, {  14,2168 }, {  15,2168 }, {  16,2168 },

 {  17,2168 }, {  18,2168 }, {  19,2168 }, {  20,2168 }, {  21,2168 },
 {  22,2168 }, {  23,2168 }, {  24,2168 }, {  25,2168 }, {  26,2168 },
 {  27,2168 }, {  28,2168 }, {  29,2168 }, {  30,2168 }, {  31,2168 },
 {  32,2168 }, {  33,2168 }, {  34,2168 }, {  35,2168 }, {  36,2168 },
 {  37,2168 }, {  38,2168 }, {  39,2168 }, {  40,2168 }, {  41,2168 },
 {  42,2168 }, {  43,2168 }, {  44,2168 }, {  45,2168 }, {  46,2168 },
 {  47,2168 }, {  48,2168 }, {  49,2168 }, {  50,2168 }, {  51,2168 },
 {  52,2168 }, {  53,2168 }, {  54,2168 }, {  55,2168 }, {  56,2168 },
 {  57,2168 }, {  58,2168 }, {  59,2168 }, {  60,2168 }, {  61,2168 },
 {  62,2168 }, {  63,2168 }, {  64,2168 }, {  65,2168 }, {  66,2168 },

 {  67,2168 }, {  68,2168 }, {  69,2168 }, {  70,2168 }, {  71,2168 },
 {  72,2168 }, {  73,2168 }, {  74,2168 }, {  75,2168 }, {  76,2168 },
 {  77,2168 }, {  78,2168 }, {  79,2168 }, {  80,2168 }, {  81,2168 },
 {  82,2168 }, {  83,2168 }, {  84,2168 }, {  85,2168 }, {  86,2168 },
 {  87,2168 }, {  88,2168 }, {  89,2168 }, {  90,2168 }, {  91,2168 },
 {  92,2168 }, {  93,2168 }, {  94,2168 }, {  95,2168 }, {  96, 906 },
 {  97,2168 }, {  98,2168 }, {  99,2168 }, { 100,2168 }, { 101,2168 },
 { 102,2168 }, { 103,2168 }, { 104,2168 }, { 105,2168 }, { 106,2168 },
 { 107,2168 }, { 108,2168 }, { 109,2168 }, { 110,2168 }, { 111,2168 },
 { 112,2168 }, { 113,2168 }, { 114,2168 }, { 115,2168 }, { 116,2168 },

 { 117,2168 }, { 118,2168 }, { 119,2168 }, { 120,2168 }, { 121,2168 },
 { 122,2168 }, { 123,2168 }, { 124,2168 }, { 125,2168 }, { 126,2168 },
 { 127,2168 }, { 128,2168 }, { 129,2168 }, { 130,2168 }, { 131,2168 },
 { 132,2168 }, { 133,2168 }, { 134,2168 }, { 135,2168 }, { 136,2168 },
 { 137,2168 }, { 138,2168 }, { 139,2168 }, { 140,2168 }, { 141,2168 },
 { 142,2168 }, { 143,2168 }, { 144,2168 }, { 145,2168 }, { 146,2168 },
 { 147,2168 }, { 148,2168 }, { 149,2168 }, { 150,2168 }, { 151,2168 },
 { 152,2168 }, { 153,2168 }, { 154,2168 }, { 155,2168 }, { 156,2168 },
 { 157,2168 }, { 158,2168 }, { 159,2168 }, { 160,2168 }, { 161,2168 },
 { 162,2168 }, { 163,2168 }, { 164,2168 }, { 165,2168 }, { 166,2168 },

 { 167,2168 }, { 168,2168 }, { 169,2168 }, { 170,2168 }, { 171,2168 },
 { 172,2168 }, { 173,2168 }, { 174,2168 }, { 175,2168 }, { 176,2168 },
 { 177,2168 }, { 178,2168 }, { 179,2168 }, { 180,2168 }, { 181,2168 },
 { 182,2168 }, { 183,2168 }, { 184,2168 }, { 185,2168 }, { 186,2168 },
 { 187,2168 }, { 188,2168 }, { 189,2168 }, { 190,2168 }, { 191,2168 },
 { 192,2168 }, { 193,2168 }, { 194,2168 }, { 195,2168 }, { 196,2168 },
 { 197,2168 }, { 198,2168 }, { 199,2168 }, { 200,2168 }, { 201,2168 },
 { 202,2168 }, { 203,2168 }, { 204,2168 }, { 205,2168 }, { 206,2168 },
 { 207,2168 }, { 208,2168 }, { 209,2168 }, { 210,2168 }, { 211,2168 },
 { 212,2168 }, { 213,2168 }, { 214,2168 }, { 215,2168 }, { 216,2168 },

 { 217,2168 }, { 218,2168 }, { 219,2168 }, { 220,2168 }, { 221,2168 },
 { 222,2168 }, { 223,2168 }, { 224,2168 }, { 225,2168 }, { 226,2168 },
 { 227,2168 }, { 228,2168 }, { 229,2168 }, { 230,2168 }, { 231,2168 },
 { 232,2168 }, { 233,2168 }, { 234,2168 }, { 235,2168 }, { 236,2168 },
 { 237,2168 }, { 238,2168 }, { 239,2168 }, { 240,2168 }, { 241,2168 },
 { 242,2168 }, { 243,2168 }, { 244,2168 }, { 245,2168 }, { 246,2168 },
 { 247,2168 }, { 248,2168 }, { 249,2168 }, { 250,2168 }, { 251,2168 },
 { 252,2168 }, { 253,2168 }, { 254,2168 }, { 255,2168 }, { 256,2168 },
 {   0,   0 }, {   0,5960 }, {   1,1910 }, {   2,1910 }, {   3,1910 },
 {   4,1910 }, {   5,1910 }, {   6,1910 }, {   7,1910 }, {   8,1910 },

 {   9,1910 }, {  10,1910 }, {  11,1910 }, {  12,1910 }, {  13,1910 },
 {  14,1910 }, {  15,1910 }, {  16,1910 }, {  17,1910 }, {  18,1910 },
 {  19,1910 }, {  20,1910 }, {  21,1910 }, {  22,1910 }, {  23,1910 },
 {  24,1910 }, {  25,1910 }, {  26,1910 }, {  27,1910 }, {  28,1910 },
 {  29,1910 }, {  30,1910 }, {  31,1910 }, {  32,1910 }, {  33,1910 },
 {  34,1910 }, {  35,1910 }, {  36,1910 }, {  37,1910 }, {  38,1910 },
 {  39,1910 }, {  40,1910 }, {  41,1910 }, {  42,1910 }, {  43,1910 },
 {  44,1910 }, {  45,1910 }, {  46,1910 }, {  47,1910 }, {  48,1910 },
 {  49,1910 }, {  50,1910 }, {  51,1910 }, {  52,1910 }, {  53,1910 },
 {  54,1910 }, {  55,1910 }, {  56,1910 }, {  57,1910 }, {  58,1910 },

 {  59,1910 }, {  60,1910 }, {  61,1910 }, {  62,1910 }, {  63,1910 },
 {  64,1910 }, {  65,1910 }, {  66,1910 }, {  67,1910 }, {  68,1910 },
 {  69,1910 }, {  70,1910 }, {  71,1910 }, {  72,1910 }, {  73,1910 },
 {  74,1910 }, {  75,1910 }, {  76,1910 }, {  77,1910 }, {  78,1910 },
 {  79,1910 }, {  80,1910 }, {  81,1910 }, {  82,1910 }, {  83,1910 },
 {  84,1910 }, {  85,1910 }, {  86,1910 }, {  87,1910 }, {  88,1910 },
 {  89,1910 }, {  90,1910 }, {  91,1910 }, {  92,1910 }, {  93,1910 },
 {  94,1910 }, {  95,1910 }, {  96, 648 }, {  97,1910 }, {  98,1910 },
 {  99,1910 }, { 100,1910 }, { 101,1910 }, { 102,1910 }, { 103,1910 },
 { 104,1910 }, { 105,1910 }, { 106,1910 }, { 107,1910 }, { 108,1910 },

 { 109,1910 }, { 110,1910 }, { 111,1910 }, { 112,1910 }, { 113,1910 },
 { 114,1910 }, { 115,1910 }, { 116,1910 }, { 117,1910 }, { 118,1910 },
 { 119,1910 }, { 120,1910 }, { 121,1910 }, { 122,1910 }, { 123,1910 },
 { 124,1910 }, { 125,1910 }, { 126,1910 }, { 127,1910 }, { 128,1910 },
 { 129,1910 }, { 130,1910 }, { 131,1910 }, { 132,1910 }, { 133,1910 },
 { 134,1910 }, { 135,1910 }, { 136,1910 }, { 137,1910 }, { 138,1910 },
 { 139,1910 }, { 140,1910 }, { 141,1910 }, { 142,1910 }, { 143,1910 },
 { 144,1910 }, { 145,1910 }, { 146,1910 }, { 147,1910 }, { 148,1910 },
 { 149,1910 }, { 150,1910 }, { 151,1910 }, { 152,1910 }, { 153,1910 },
 { 154,1910 }, { 155,1910 }, { 156,1910 }, { 157,1910 }, { 158,1910 },

 { 159,1910 }, { 160,1910 }, { 161,1910 }, { 162,1910 }, { 163,1910 },
 { 164,1910 }, { 165,1910 }, { 166,1910 }, { 167,1910 }, { 168,1910 },
 { 169,1910 }, { 170,1910 }, { 171,1910 }, { 172,1910 }, { 173,1910 },
 { 174,1910 }, { 175,1910 }, { 176,1910 }, { 177,1910 }, { 178,1910 },
 { 179,1910 }, { 180,1910 }, { 181,1910 }, { 182,1910 }, { 183,1910 },
 { 184,1910 }, { 185,1910 }, { 186,1910 }, { 187,1910 }, { 188,1910 },
 { 189,1910 }, { 190,1910 }, { 191,1910 }, { 192,1910 }, { 193,1910 },
 { 194,1910 }, { 195,1910 }, { 196,1910 }, { 197,1910 }, { 198,1910 },
 { 199,1910 }, { 200,1910 }, { 201,1910 }, { 202,1910 }, { 203,1910 },
 { 204,1910 }, { 205,1910 }, { 206,1910 }, { 207,1910 }, { 208,1910 },

 { 209,1910 }, { 210,1910 }, { 211,1910 }, { 212,1910 }, { 213,1910 },
 { 214,1910 }, { 215,1910 }, { 216,1910 }, { 217,1910 }, { 218,1910 },
 { 219,1910 }, { 220,1910 }, { 221,1910 }, { 222,1910 }, { 223,1910 },
 { 224,1910 }, { 225,1910 }, { 226,1910 }, { 227,1910 }, { 228,1910 },
 { 229,1910 }, { 230,1910 }, { 231,1910 }, { 232,1910 }, { 233,1910 },
 { 234,1910 }, { 235,1910 }, { 236,1910 }, { 237,1910 }, { 238,1910 },
 { 239,1910 }, { 240,1910 }, { 241,1910 }, { 242,1910 }, { 243,1910 },
 { 244,1910 }, { 245,1910 }, { 246,1910 }, { 247,1910 }, { 248,1910 },
 { 249,1910 }, { 250,1910 }, { 251,1910 }, { 252,1910 }, { 253,1910 },
 { 254,1910 }, { 255,1910 }, { 256,1910 }, {   0,  40 }, {   0,5702 },

 {   0,   1 }, {   0,5700 }, {   0,  14 }, {   0,5698 }, {   0,   0 },
 {   0,   1 }, {   0,5695 }, {   0,  40 }, {   0,5693 }, {   0,   0 },
 {   9,1908 }, {  10,1908 }, {  11,1908 }, {  12,1908 }, {  13,1908 },
 {   9,1903 }, {  10,1903 }, {  11,1903 }, {  12,1903 }, {  13,1903 },
 {   0,  39 }, {   0,5680 }, {   0,  15 }, {   0,5678 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  32,1908 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  32,1903 }, {   0,  39 },
 {   0,5661 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,  39 }, {   0,5644 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65,1903 }, {  66,1903 },
 {  67,1903 }, {  68,1903 }, {  69,1903 }, {  70,1903 }, {  71,1903 },
 {  72,1903 }, {  73,1903 }, {  74,1903 }, {  75,1903 }, {  76,1903 },
 {  77,1903 }, {  78,1903 }, {  79,1903 }, {  80,1903 }, {  81,1903 },
 {  82,1903 }, {  83,1903 }, {  84,1903 }, {  85,1903 }, {  86,1903 },
 {  87,1903 }, {  88,1903 }, {  89,1903 }, {  90,1903 }, {  42, 338 },

 {   0,   0 }, {  61, 351 }, {   0,   0 }, {  95,1903 }, {  47,2199 },
 {  97,1903 }, {  98,1903 }, {  99,1903 }, { 100,1903 }, { 101,1903 },
 { 102,1903 }, { 103,1903 }, { 104,1903 }, { 105,1903 }, { 106,1903 },
 { 107,1903 }, { 108,1903 }, { 109,1903 }, { 110,1903 }, { 111,1903 },
 { 112,1903 }, { 113,1903 }, { 114,1903 }, { 115,1903 }, { 116,1903 },
 { 117,1903 }, { 118,1903 }, { 119,1903 }, { 120,1903 }, { 121,1903 },
 { 122,1903 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, { 128,1903 }, { 129,1903 }, { 130,1903 }, { 131,1903 },
 { 132,1903 }, { 133,1903 }, { 134,1903 }, { 135,1903 }, { 136,1903 },
 { 137,1903 }, { 138,1903 }, { 139,1903 }, { 140,1903 }, { 141,1903 },

 { 142,1903 }, { 143,1903 }, { 144,1903 }, { 145,1903 }, { 146,1903 },
 { 147,1903 }, { 148,1903 }, { 149,1903 }, { 150,1903 }, { 151,1903 },
 { 152,1903 }, { 153,1903 }, { 154,1903 }, { 155,1903 }, { 156,1903 },
 { 157,1903 }, { 158,1903 }, { 159,1903 }, { 160,1903 }, { 161,1903 },
 { 162,1903 }, { 163,1903 }, { 164,1903 }, { 165,1903 }, { 166,1903 },
 { 167,1903 }, { 168,1903 }, { 169,1903 }, { 170,1903 }, { 171,1903 },
 { 172,1903 }, { 173,1903 }, { 174,1903 }, { 175,1903 }, { 176,1903 },
 { 177,1903 }, { 178,1903 }, { 179,1903 }, { 180,1903 }, { 181,1903 },
 { 182,1903 }, { 183,1903 }, { 184,1903 }, { 185,1903 }, { 186,1903 },
 { 187,1903 }, { 188,1903 }, { 189,1903 }, { 190,1903 }, { 191,1903 },

 { 192,1903 }, { 193,1903 }, { 194,1903 }, { 195,1903 }, { 196,1903 },
 { 197,1903 }, { 198,1903 }, { 199,1903 }, { 200,1903 }, { 201,1903 },
 { 202,1903 }, { 203,1903 }, { 204,1903 }, { 205,1903 }, { 206,1903 },
 { 207,1903 }, { 208,1903 }, { 209,1903 }, { 210,1903 }, { 211,1903 },
 { 212,1903 }, { 213,1903 }, { 214,1903 }, { 215,1903 }, { 216,1903 },
 { 217,1903 }, { 218,1903 }, { 219,1903 }, { 220,1903 }, { 221,1903 },
 { 222,1903 }, { 223,1903 }, { 224,1903 }, { 225,1903 }, { 226,1903 },
 { 227,1903 }, { 228,1903 }, { 229,1903 }, { 230,1903 }, { 231,1903 },
 { 232,1903 }, { 233,1903 }, { 234,1903 }, { 235,1903 }, { 236,1903 },
 { 237,1903 }, { 238,1903 }, { 239,1903 }, { 240,1903 }, { 241,1903 },

 { 242,1903 }, { 243,1903 }, { 244,1903 }, { 245,1903 }, { 246,1903 },
 { 247,1903 }, { 248,1903 }, { 249,1903 }, { 250,1903 }, { 251,1903 },
 { 252,1903 }, { 253,1903 }, { 254,1903 }, { 255,1903 }, {   0,  39 },
 {   0,5436 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   6 }, {   0,5424 }, {   0,  39 }, {   0,5422 },
 {   0,  39 }, {   0,5420 }, {   0,  39 }, {   0,5418 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,  39 }, {   0,5405 }, {   0,   0 }, {   0,   6 }, {   0,5402 },

 {   0,  27 }, {   0,5400 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  46, 128 }, {   0,   0 }, {  48,1903 }, {  49,1903 },
 {  50,1903 }, {  51,1903 }, {  52,1903 }, {  53,1903 }, {  54,1903 },
 {  55,1903 }, {  56,1903 }, {  57,1903 }, {  46,2237 }, {   0,   0 },
 {  48,2259 }, {  49,2259 }, {  50,2259 }, {  51,2259 }, {  52,2259 },
 {  53,2259 }, {  54,2259 }, {  55,2259 }, {  56,2259 }, {  57,2259 },
 {   0,   0 }, {   0,   0 }, {  58, 123 }, {   0,   3 }, {   0,5362 },
 {   0,  24 }, {   0,5360 }, {  61, 123 }, {  62, 125 }, {   0,   0 },
 {  46,2215 }, {  69,2296 }, {  48,2237 }, {  49,2237 }, {  50,2237 },

 {  51,2237 }, {  52,2237 }, {  53,2237 }, {  54,2237 }, {  55,2237 },
 {  56,2237 }, {  57,2237 }, {  61, 125 }, {   0,  25 }, {   0,5342 },
 {   0,   0 }, {   0,  26 }, {   0,5339 }, {   0,  23 }, {   0,5337 },
 {  88,2318 }, {   0,   0 }, {   0,   0 }, {  69,2274 }, {   0,  23 },
 {   0,5331 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, { 101,2296 }, {   0,   0 },
 {   0,   0 }, {  42,1588 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  47,1590 }, {   0,   0 }, {   0,  30 }, {   0,5312 },
 {   0,  36 }, {   0,5310 }, {   0,  35 }, {   0,5308 }, {   0,   2 },
 {   0,5306 }, {   0,   0 }, { 120,2318 }, {  36,2271 }, {   0,   0 },

 { 101,2274 }, {   0,  38 }, {   0,5299 }, {   0,  33 }, {   0,5297 },
 {   0,  32 }, {   0,5295 }, {   0,  37 }, {   0,5293 }, { 126, 125 },
 {  48,2271 }, {  49,2271 }, {  50,2271 }, {  51,2271 }, {  52,2271 },
 {  53,2271 }, {  54,2271 }, {  55,2271 }, {  56,2271 }, {  57,2271 },
 {   0,  34 }, {   0,5280 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  65,2271 }, {  66,2271 }, {  67,2271 },
 {  68,2271 }, {  69,2271 }, {  70,2271 }, {  71,2271 }, {  72,2271 },
 {  73,2271 }, {  74,2271 }, {  75,2271 }, {  76,2271 }, {  77,2271 },
 {  78,2271 }, {  79,2271 }, {  80,2271 }, {  81,2271 }, {  82,2271 },
 {  83,2271 }, {  84,2271 }, {  85,2271 }, {  86,2271 }, {  87,2271 },

 {  88,2271 }, {  89,2271 }, {  90,2271 }, {   0,   0 }, {   0,   0 },
 {  85,3421 }, {   0,   0 }, {  95,2271 }, {   0,   0 }, {  97,2271 },
 {  98,2271 }, {  99,2271 }, { 100,2271 }, { 101,2271 }, { 102,2271 },
 { 103,2271 }, { 104,2271 }, { 105,2271 }, { 106,2271 }, { 107,2271 },
 { 108,2271 }, { 109,2271 }, { 110,2271 }, { 111,2271 }, { 112,2271 },
 { 113,2271 }, { 114,2271 }, { 115,2271 }, { 116,2271 }, { 117,2271 },
 { 118,2271 }, { 119,2271 }, { 120,2271 }, { 121,2271 }, { 122,2271 },
 {  96,1546 }, {   0,   0 }, { 117,3444 }, {   0,   0 }, {   0,   0 },
 { 128,2271 }, { 129,2271 }, { 130,2271 }, { 131,2271 }, { 132,2271 },
 { 133,2271 }, { 134,2271 }, { 135,2271 }, { 136,2271 }, { 137,2271 },

 { 138,2271 }, { 139,2271 }, { 140,2271 }, { 141,2271 }, { 142,2271 },
 { 143,2271 }, { 144,2271 }, { 145,2271 }, { 146,2271 }, { 147,2271 },
 { 148,2271 }, { 149,2271 }, { 150,2271 }, { 151,2271 }, { 152,2271 },
 { 153,2271 }, { 154,2271 }, { 155,2271 }, { 156,2271 }, { 157,2271 },
 { 158,2271 }, { 159,2271 }, { 160,2271 }, { 161,2271 }, { 162,2271 },
 { 163,2271 }, { 164,2271 }, { 165,2271 }, { 166,2271 }, { 167,2271 },
 { 168,2271 }, { 169,2271 }, { 170,2271 }, { 171,2271 }, { 172,2271 },
 { 173,2271 }, { 174,2271 }, { 175,2271 }, { 176,2271 }, { 177,2271 },
 { 178,2271 }, { 179,2271 }, { 180,2271 }, { 181,2271 }, { 182,2271 },
 { 183,2271 }, { 184,2271 }, { 185,2271 }, { 186,2271 }, { 187,2271 },

 { 188,2271 }, { 189,2271 }, { 190,2271 }, { 191,2271 }, { 192,2271 },
 { 193,2271 }, { 194,2271 }, { 195,2271 }, { 196,2271 }, { 197,2271 },
 { 198,2271 }, { 199,2271 }, { 200,2271 }, { 201,2271 }, { 202,2271 },
 { 203,2271 }, { 204,2271 }, { 205,2271 }, { 206,2271 }, { 207,2271 },
 { 208,2271 }, { 209,2271 }, { 210,2271 }, { 211,2271 }, { 212,2271 },
 { 213,2271 }, { 214,2271 }, { 215,2271 }, { 216,2271 }, { 217,2271 },
 { 218,2271 }, { 219,2271 }, { 220,2271 }, { 221,2271 }, { 222,2271 },
 { 223,2271 }, { 224,2271 }, { 225,2271 }, { 226,2271 }, { 227,2271 },
 { 228,2271 }, { 229,2271 }, { 230,2271 }, { 231,2271 }, { 232,2271 },
 { 233,2271 }, { 234,2271 }, { 235,2271 }, { 236,2271 }, { 237,2271 },

 { 238,2271 }, { 239,2271 }, { 240,2271 }, { 241,2271 }, { 242,2271 },
 { 243,2271 }, { 244,2271 }, { 245,2271 }, { 246,2271 }, { 247,2271 },
 { 248,2271 }, { 249,2271 }, { 250,2271 }, { 251,2271 }, { 252,2271 },
 { 253,2271 }, { 254,2271 }, { 255,2271 }, {   0,   3 }, {   0,5082 },
 {   1,2271 }, {   2,2271 }, {   3,2271 }, {   4,2271 }, {   5,2271 },
 {   6,2271 }, {   7,2271 }, {   8,2271 }, {   9,2271 }, {  10,2271 },
 {  11,2271 }, {  12,2271 }, {  13,2271 }, {  14,2271 }, {  15,2271 },
 {  16,2271 }, {  17,2271 }, {  18,2271 }, {  19,2271 }, {  20,2271 },
 {  21,2271 }, {  22,2271 }, {  23,2271 }, {  24,2271 }, {  25,2271 },
 {  26,2271 }, {  27,2271 }, {  28,2271 }, {  29,2271 }, {  30,2271 },

 {  31,2271 }, {  32,2271 }, {  33,2271 }, {  34,2271 }, {  35,2271 },
 {  36,2271 }, {  37,2271 }, {  38,2271 }, {  39,2271 }, {  40,2271 },
 {  41,2271 }, {   0,   0 }, {  43,2271 }, {  44,2271 }, {  45,2271 },
 {  46,2271 }, {  47,2271 }, {  48,2271 }, {  49,2271 }, {  50,2271 },
 {  51,2271 }, {  52,2271 }, {  53,2271 }, {  54,2271 }, {  55,2271 },
 {  56,2271 }, {  57,2271 }, {  58,2271 }, {  59,2271 }, {  60,2271 },
 {  61,2271 }, {  62,2271 }, {  63,2271 }, {  64,2271 }, {  65,2271 },
 {  66,2271 }, {  67,2271 }, {  68,2271 }, {  69,2271 }, {  70,2271 },
 {  71,2271 }, {  72,2271 }, {  73,2271 }, {  74,2271 }, {  75,2271 },
 {  76,2271 }, {  77,2271 }, {  78,2271 }, {  79,2271 }, {  80,2271 },

 {  81,2271 }, {  82,2271 }, {  83,2271 }, {  84,2271 }, {  85,2271 },
 {  86,2271 }, {  87,2271 }, {  88,2271 }, {  89,2271 }, {  90,2271 },
 {  91,2271 }, {  92,2271 }, {  93,2271 }, {  94,2271 }, {  95,2271 },
 {  96,2271 }, {  97,2271 }, {  98,2271 }, {  99,2271 }, { 100,2271 },
 { 101,2271 }, { 102,2271 }, { 103,2271 }, { 104,2271 }, { 105,2271 },
 { 106,2271 }, { 107,2271 }, { 108,2271 }, { 109,2271 }, { 110,2271 },
 { 111,2271 }, { 112,2271 }, { 113,2271 }, { 114,2271 }, { 115,2271 },
 { 116,2271 }, { 117,2271 }, { 118,2271 }, { 119,2271 }, { 120,2271 },
 { 121,2271 }, { 122,2271 }, { 123,2271 }, { 124,2271 }, { 125,2271 },
 { 126,2271 }, { 127,2271 }, { 128,2271 }, { 129,2271 }, { 130,2271 },

 { 131,2271 }, { 132,2271 }, { 133,2271 }, { 134,2271 }, { 135,2271 },
 { 136,2271 }, { 137,2271 }, { 138,2271 }, { 139,2271 }, { 140,2271 },
 { 141,2271 }, { 142,2271 }, { 143,2271 }, { 144,2271 }, { 145,2271 },
 { 146,2271 }, { 147,2271 }, { 148,2271 }, { 149,2271 }, { 150,2271 },
 { 151,2271 }, { 152,2271 }, { 153,2271 }, { 154,2271 }, { 155,2271 },
 { 156,2271 }, { 157,2271 }, { 158,2271 }, { 159,2271 }, { 160,2271 },
 { 161,2271 }, { 162,2271 }, { 163,2271 }, { 164,2271 }, { 165,2271 },
 { 166,2271 }, { 167,2271 }, { 168,2271 }, { 169,2271 }, { 170,2271 },
 { 171,2271 }, { 172,2271 }, { 173,2271 }, { 174,2271 }, { 175,2271 },
 { 176,2271 }, { 177,2271 }, { 178,2271 }, { 179,2271 }, { 180,2271 },

 { 181,2271 }, { 182,2271 }, { 183,2271 }, { 184,2271 }, { 185,2271 },
 { 186,2271 }, { 187,2271 }, { 188,2271 }, { 189,2271 }, { 190,2271 },
 { 191,2271 }, { 192,2271 }, { 193,2271 }, { 194,2271 }, { 195,2271 },
 { 196,2271 }, { 197,2271 }, { 198,2271 }, { 199,2271 }, { 200,2271 },
 { 201,2271 }, { 202,2271 }, { 203,2271 }, { 204,2271 }, { 205,2271 },
 { 206,2271 }, { 207,2271 }, { 208,2271 }, { 209,2271 }, { 210,2271 },
 { 211,2271 }, { 212,2271 }, { 213,2271 }, { 214,2271 }, { 215,2271 },
 { 216,2271 }, { 217,2271 }, { 218,2271 }, { 219,2271 }, { 220,2271 },
 { 221,2271 }, { 222,2271 }, { 223,2271 }, { 224,2271 }, { 225,2271 },
 { 226,2271 }, { 227,2271 }, { 228,2271 }, { 229,2271 }, { 230,2271 },

 { 231,2271 }, { 232,2271 }, { 233,2271 }, { 234,2271 }, { 235,2271 },
 { 236,2271 }, { 237,2271 }, { 238,2271 }, { 239,2271 }, { 240,2271 },
 { 241,2271 }, { 242,2271 }, { 243,2271 }, { 244,2271 }, { 245,2271 },
 { 246,2271 }, { 247,2271 }, { 248,2271 }, { 249,2271 }, { 250,2271 },
 { 251,2271 }, { 252,2271 }, { 253,2271 }, { 254,2271 }, { 255,2271 },
 { 256,2271 }, {   0,  16 }, {   0,4824 }, {   1,2271 }, {   2,2271 },
 {   3,2271 }, {   4,2271 }, {   5,2271 }, {   6,2271 }, {   7,2271 },
 {   8,2271 }, {   9,2271 }, {  10,2271 }, {  11,2271 }, {  12,2271 },
 {  13,2271 }, {  14,2271 }, {  15,2271 }, {  16,2271 }, {  17,2271 },
 {  18,2271 }, {  19,2271 }, {  20,2271 }, {  21,2271 }, {  22,2271 },

 {  23,2271 }, {  24,2271 }, {  25,2271 }, {  26,2271 }, {  27,2271 },
 {  28,2271 }, {  29,2271 }, {  30,2271 }, {  31,2271 }, {  32,2271 },
 {  33,2271 }, {   0,   0 }, {  35,2271 }, {  36,2271 }, {  37,2271 },
 {  38,2271 }, {  39,2271 }, {  40,2271 }, {  41,2271 }, {  42,2271 },
 {  43,2271 }, {  44,2271 }, {  45,2271 }, {  46,2271 }, {  47,2271 },
 {  48,2271 }, {  49,2271 }, {  50,2271 }, {  51,2271 }, {  52,2271 },
 {  53,2271 }, {  54,2271 }, {  55,2271 }, {  56,2271 }, {  57,2271 },
 {  58,2271 }, {  59,2271 }, {  60,2271 }, {  61,2271 }, {  62,2271 },
 {  63,2271 }, {  64,2271 }, {  65,2271 }, {  66,2271 }, {  67,2271 },
 {  68,2271 }, {  69,2271 }, {  70,2271 }, {  71,2271 }, {  72,2271 },

 {  73,2271 }, {  74,2271 }, {  75,2271 }, {  76,2271 }, {  77,2271 },
 {  78,2271 }, {  79,2271 }, {  80,2271 }, {  81,2271 }, {  82,2271 },
 {  83,2271 }, {  84,2271 }, {  85,2271 }, {  86,2271 }, {  87,2271 },
 {  88,2271 }, {  89,2271 }, {  90,2271 }, {  91,2271 }, {   0,   0 },
 {  93,2271 }, {  94,2271 }, {  95,2271 }, {  96,2271 }, {  97,2271 },
 {  98,2271 }, {  99,2271 }, { 100,2271 }, { 101,2271 }, { 102,2271 },
 { 103,2271 }, { 104,2271 }, { 105,2271 }, { 106,2271 }, { 107,2271 },
 { 108,2271 }, { 109,2271 }, { 110,2271 }, { 111,2271 }, { 112,2271 },
 { 113,2271 }, { 114,2271 }, { 115,2271 }, { 116,2271 }, { 117,2271 },
 { 118,2271 }, { 119,2271 }, { 120,2271 }, { 121,2271 }, { 122,2271 },

 { 123,2271 }, { 124,2271 }, { 125,2271 }, { 126,2271 }, { 127,2271 },
 { 128,2271 }, { 129,2271 }, { 130,2271 }, { 131,2271 }, { 132,2271 },
 { 133,2271 }, { 134,2271 }, { 135,2271 }, { 136,2271 }, { 137,2271 },
 { 138,2271 }, { 139,2271 }, { 140,2271 }, { 141,2271 }, { 142,2271 },
 { 143,2271 }, { 144,2271 }, { 145,2271 }, { 146,2271 }, { 147,2271 },
 { 148,2271 }, { 149,2271 }, { 150,2271 }, { 151,2271 }, { 152,2271 },
 { 153,2271 }, { 154,2271 }, { 155,2271 }, { 156,2271 }, { 157,2271 },
 { 158,2271 }, { 159,2271 }, { 160,2271 }, { 161,2271 }, { 162,2271 },
 { 163,2271 }, { 164,2271 }, { 165,2271 }, { 166,2271 }, { 167,2271 },
 { 168,2271 }, { 169,2271 }, { 170,2271 }, { 171,2271 }, { 172,2271 },

 { 173,2271 }, { 174,2271 }, { 175,2271 }, { 176,2271 }, { 177,2271 },
 { 178,2271 }, { 179,2271 }, { 180,2271 }, { 181,2271 }, { 182,2271 },
 { 183,2271 }, { 184,2271 }, { 185,2271 }, { 186,2271 }, { 187,2271 },
 { 188,2271 }, { 189,2271 }, { 190,2271 }, { 191,2271 }, { 192,2271 },
 { 193,2271 }, { 194,2271 }, { 195,2271 }, { 196,2271 }, { 197,2271 },
 { 198,2271 }, { 199,2271 }, { 200,2271 }, { 201,2271 }, { 202,2271 },
 { 203,2271 }, { 204,2271 }, { 205,2271 }, { 206,2271 }, { 207,2271 },
 { 208,2271 }, { 209,2271 }, { 210,2271 }, { 211,2271 }, { 212,2271 },
 { 213,2271 }, { 214,2271 }, { 215,2271 }, { 216,2271 }, { 217,2271 },
 { 218,2271 }, { 219,2271 }, { 220,2271 }, { 221,2271 }, { 222,2271 },

 { 223,2271 }, { 224,2271 }, { 225,2271 }, { 226,2271 }, { 227,2271 },
 { 228,2271 }, { 229,2271 }, { 230,2271 }, { 231,2271 }, { 232,2271 },
 { 233,2271 }, { 234,2271 }, { 235,2271 }, { 236,2271 }, { 237,2271 },
 { 238,2271 }, { 239,2271 }, { 240,2271 }, { 241,2271 }, { 242,2271 },
 { 243,2271 }, { 244,2271 }, { 245,2271 }, { 246,2271 }, { 247,2271 },
 { 248,2271 }, { 249,2271 }, { 250,2271 }, { 251,2271 }, { 252,2271 },
 { 253,2271 }, { 254,2271 }, { 255,2271 }, { 256,2271 }, {   0,  19 },
 {   0,4566 }, {   1, 796 }, {   2, 796 }, {   3, 796 }, {   4, 796 },
 {   5, 796 }, {   6, 796 }, {   7, 796 }, {   8, 796 }, {   9, 796 },
 {  10, 796 }, {  11, 796 }, {  12, 796 }, {  13, 796 }, {  14, 796 },

 {  15, 796 }, {  16, 796 }, {  17, 796 }, {  18, 796 }, {  19, 796 },
 {  20, 796 }, {  21, 796 }, {  22, 796 }, {  23, 796 }, {  24, 796 },
 {  25, 796 }, {  26, 796 }, {  27, 796 }, {  28, 796 }, {  29, 796 },
 {  30, 796 }, {  31, 796 }, {  32, 796 }, {  33, 796 }, {  34, 798 },
 {  35, 796 }, {  36, 796 }, {  37, 796 }, {  38, 796 }, {  39, 798 },
 {  40, 796 }, {  41, 796 }, {  42, 796 }, {  43, 796 }, {  44, 796 },
 {  45, 796 }, {  46, 796 }, {  47, 798 }, {  48, 796 }, {  49, 796 },
 {  50, 796 }, {  51, 796 }, {  52, 796 }, {  53, 796 }, {  54, 796 },
 {  55, 796 }, {  56, 796 }, {  57, 796 }, {  58, 796 }, {  59, 796 },
 {  60, 796 }, {  61, 796 }, {  62, 796 }, {  63, 796 }, {  64, 796 },

 {  65, 796 }, {  66, 796 }, {  67, 796 }, {  68, 796 }, {  69, 796 },
 {  70, 796 }, {  71, 796 }, {  72, 796 }, {  73, 796 }, {  74, 796 },
 {  75, 796 }, {  76, 796 }, {  77, 796 }, {  78, 796 }, {  79, 796 },
 {  80, 796 }, {  81, 796 }, {  82, 796 }, {  83, 796 }, {  84, 796 },
 {  85,2271 }, {  86, 796 }, {  87, 796 }, {  88, 796 }, {  89, 796 },
 {  90, 796 }, {  91, 796 }, {  92, 798 }, {  93, 796 }, {  94, 796 },
 {  95, 796 }, {  96, 796 }, {  97, 796 }, {  98, 798 }, {  99, 796 },
 { 100, 796 }, { 101, 796 }, { 102, 798 }, { 103, 796 }, { 104, 796 },
 { 105, 796 }, { 106, 796 }, { 107, 796 }, { 108, 796 }, { 109, 796 },
 { 110, 798 }, { 111, 796 }, { 112, 796 }, { 113, 796 }, { 114, 798 },

 { 115, 796 }, { 116, 798 }, { 117,2294 }, { 118, 796 }, { 119, 796 },
 { 120, 796 }, { 121, 796 }, { 122, 796 }, { 123, 796 }, { 124, 796 },
 { 125, 796 }, { 126, 796 }, { 127, 796 }, { 128, 796 }, { 129, 796 },
 { 130, 796 }, { 131, 796 }, { 132, 796 }, { 133, 796 }, { 134, 796 },
 { 135, 796 }, { 136, 796 }, { 137, 796 }, { 138, 796 }, { 139, 796 },
 { 140, 796 }, { 141, 796 }, { 142, 796 }, { 143, 796 }, { 144, 796 },
 { 145, 796 }, { 146, 796 }, { 147, 796 }, { 148, 796 }, { 149, 796 },
 { 150, 796 }, { 151, 796 }, { 152, 796 }, { 153, 796 }, { 154, 796 },
 { 155, 796 }, { 156, 796 }, { 157, 796 }, { 158, 796 }, { 159, 796 },
 { 160, 796 }, { 161, 796 }, { 162, 796 }, { 163, 796 }, { 164, 796 },

 { 165, 796 }, { 166, 796 }, { 167, 796 }, { 168, 796 }, { 169, 796 },
 { 170, 796 }, { 171, 796 }, { 172, 796 }, { 173, 796 }, { 174, 796 },
 { 175, 796 }, { 176, 796 }, { 177, 796 }, { 178, 796 }, { 179, 796 },
 { 180, 796 }, { 181, 796 }, { 182, 796 }, { 183, 796 }, { 184, 796 },
 { 185, 796 }, { 186, 796 }, { 187, 796 }, { 188, 796 }, { 189, 796 },
 { 190, 796 }, { 191, 796 }, { 192, 796 }, { 193, 796 }, { 194, 796 },
 { 195, 796 }, { 196, 796 }, { 197, 796 }, { 198, 796 }, { 199, 796 },
 { 200, 796 }, { 201, 796 }, { 202, 796 }, { 203, 796 }, { 204, 796 },
 { 205, 796 }, { 206, 796 }, { 207, 796 }, { 208, 796 }, { 209, 796 },
 { 210, 796 }, { 211, 796 }, { 212, 796 }, { 213, 796 }, { 214, 796 },

 { 215, 796 }, { 216, 796 }, { 217, 796 }, { 218, 796 }, { 219, 796 },
 { 220, 796 }, { 221, 796 }, { 222, 796 }, { 223, 796 }, { 224, 796 },
 { 225, 796 }, { 226, 796 }, { 227, 796 }, { 228, 796 }, { 229, 796 },
 { 230, 796 }, { 231, 796 }, { 232, 796 }, { 233, 796 }, { 234, 796 },
 { 235, 796 }, { 236, 796 }, { 237, 796 }, { 238, 796 }, { 239, 796 },
 { 240, 796 }, { 241, 796 }, { 242, 796 }, { 243, 796 }, { 244, 796 },
 { 245, 796 }, { 246, 796 }, { 247, 796 }, { 248, 796 }, { 249, 796 },
 { 250, 796 }, { 251, 796 }, { 252, 796 }, { 253, 796 }, { 254, 796 },
 { 255, 796 }, { 256, 796 }, {   0,  17 }, {   0,4308 }, {   1,2140 },
 {   2,2140 }, {   3,2140 }, {   4,2140 }, {   5,2140 }, {   6,2140 },

 {   7,2140 }, {   8,2140 }, {   9,2140 }, {  10,2140 }, {  11,2140 },
 {  12,2140 }, {  13,2140 }, {  14,2140 }, {  15,2140 }, {  16,2140 },
 {  17,2140 }, {  18,2140 }, {  19,2140 }, {  20,2140 }, {  21,2140 },
 {  22,2140 }, {  23,2140 }, {  24,2140 }, {  25,2140 }, {  26,2140 },
 {  27,2140 }, {  28,2140 }, {  29,2140 }, {  30,2140 }, {  31,2140 },
 {  32,2140 }, {  33,2140 }, {  34,2140 }, {  35,2140 }, {  36,2140 },
 {  37,2140 }, {  38,2140 }, {   0,   0 }, {  40,2140 }, {  41,2140 },
 {  42,2140 }, {  43,2140 }, {  44,2140 }, {  45,2140 }, {  46,2140 },
 {  47,2140 }, {  48,2140 }, {  49,2140 }, {  50,2140 }, {  51,2140 },
 {  52,2140 }, {  53,2140 }, {  54,2140 }, {  55,2140 }, {  56,2140 },

 {  57,2140 }, {  58,2140 }, {  59,2140 }, {  60,2140 }, {  61,2140 },
 {  62,2140 }, {  63,2140 }, {  64,2140 }, {  65,2140 }, {  66,2140 },
 {  67,2140 }, {  68,2140 }, {  69,2140 }, {  70,2140 }, {  71,2140 },
 {  72,2140 }, {  73,2140 }, {  74,2140 }, {  75,2140 }, {  76,2140 },
 {  77,2140 }, {  78,2140 }, {  79,2140 }, {  80,2140 }, {  81,2140 },
 {  82,2140 }, {  83,2140 }, {  84,2140 }, {  85,2140 }, {  86,2140 },
 {  87,2140 }, {  88,2140 }, {  89,2140 }, {  90,2140 }, {  91,2140 },
 {   0,   0 }, {  93,2140 }, {  94,2140 }, {  95,2140 }, {  96,2140 },
 {  97,2140 }, {  98,2140 }, {  99,2140 }, { 100,2140 }, { 101,2140 },
 { 102,2140 }, { 103,2140 }, { 104,2140 }, { 105,2140 }, { 106,2140 },

 { 107,2140 }, { 108,2140 }, { 109,2140 }, { 110,2140 }, { 111,2140 },
 { 112,2140 }, { 113,2140 }, { 114,2140 }, { 115,2140 }, { 116,2140 },
 { 117,2140 }, { 118,2140 }, { 119,2140 }, { 120,2140 }, { 121,2140 },
 { 122,2140 }, { 123,2140 }, { 124,2140 }, { 125,2140 }, { 126,2140 },
 { 127,2140 }, { 128,2140 }, { 129,2140 }, { 130,2140 }, { 131,2140 },
 { 132,2140 }, { 133,2140 }, { 134,2140 }, { 135,2140 }, { 136,2140 },
 { 137,2140 }, { 138,2140 }, { 139,2140 }, { 140,2140 }, { 141,2140 },
 { 142,2140 }, { 143,2140 }, { 144,2140 }, { 145,2140 }, { 146,2140 },
 { 147,2140 }, { 148,2140 }, { 149,2140 }, { 150,2140 }, { 151,2140 },
 { 152,2140 }, { 153,2140 }, { 154,2140 }, { 155,2140 }, { 156,2140 },

 { 157,2140 }, { 158,2140 }, { 159,2140 }, { 160,2140 }, { 161,2140 },
 { 162,2140 }, { 163,2140 }, { 164,2140 }, { 165,2140 }, { 166,2140 },
 { 167,2140 }, { 168,2140 }, { 169,2140 }, { 170,2140 }, { 171,2140 },
 { 172,2140 }, { 173,2140 }, { 174,2140 }, { 175,2140 }, { 176,2140 },
 { 177,2140 }, { 178,2140 }, { 179,2140 }, { 180,2140 }, { 181,2140 },
 { 182,2140 }, { 183,2140 }, { 184,2140 }, { 185,2140 }, { 186,2140 },
 { 187,2140 }, { 188,2140 }, { 189,2140 }, { 190,2140 }, { 191,2140 },
 { 192,2140 }, { 193,2140 }, { 194,2140 }, { 195,2140 }, { 196,2140 },
 { 197,2140 }, { 198,2140 }, { 199,2140 }, { 200,2140 }, { 201,2140 },
 { 202,2140 }, { 203,2140 }, { 204,2140 }, { 205,2140 }, { 206,2140 },

 { 207,2140 }, { 208,2140 }, { 209,2140 }, { 210,2140 }, { 211,2140 },
 { 212,2140 }, { 213,2140 }, { 214,2140 }, { 215,2140 }, { 216,2140 },
 { 217,2140 }, { 218,2140 }, { 219,2140 }, { 220,2140 }, { 221,2140 },
 { 222,2140 }, { 223,2140 }, { 224,2140 }, { 225,2140 }, { 226,2140 },
 { 227,2140 }, { 228,2140 }, { 229,2140 }, { 230,2140 }, { 231,2140 },
 { 232,2140 }, { 233,2140 }, { 234,2140 }, { 235,2140 }, { 236,2140 },
 { 237,2140 }, { 238,2140 }, { 239,2140 }, { 240,2140 }, { 241,2140 },
 { 242,2140 }, { 243,2140 }, { 244,2140 }, { 245,2140 }, { 246,2140 },
 { 247,2140 }, { 248,2140 }, { 249,2140 }, { 250,2140 }, { 251,2140 },
 { 252,2140 }, { 253,2140 }, { 254,2140 }, { 255,2140 }, { 256,2140 },

 {   0,  28 }, {   0,4050 }, {   1,2267 }, {   2,2267 }, {   3,2267 },
 {   4,2267 }, {   5,2267 }, {   6,2267 }, {   7,2267 }, {   8,2267 },
 {   9,2267 }, {  10,2267 }, {  11,2267 }, {  12,2267 }, {  13,2267 },
 {  14,2267 }, {  15,2267 }, {  16,2267 }, {  17,2267 }, {  18,2267 },
 {  19,2267 }, {  20,2267 }, {  21,2267 }, {  22,2267 }, {  23,2267 },
 {  24,2267 }, {  25,2267 }, {  26,2267 }, {  27,2267 }, {  28,2267 },
 {  29,2267 }, {  30,2267 }, {  31,2267 }, {  32,2267 }, {  33,2267 },
 {  34,2267 }, {  35,2267 }, {  36,2267 }, {  37,2267 }, {  38,2267 },
 {  39,2267 }, {  40,2267 }, {  41,2267 }, {  42,2267 }, {  43,2267 },
 {  44,2267 }, {  45,2267 }, {  46,2267 }, {  47,2267 }, {  48,2267 },

 {  49,2267 }, {  50,2267 }, {  51,2267 }, {  52,2267 }, {  53,2267 },
 {  54,2267 }, {  55,2267 }, {  56,2267 }, {  57,2267 }, {  58,2267 },
 {  59,2267 }, {  60,2267 }, {  61,2267 }, {  62,2267 }, {  63,2267 },
 {  64,2267 }, {  65,2267 }, {  66,2267 }, {  67,2267 }, {  68,2267 },
 {  69,2267 }, {  70,2267 }, {  71,2267 }, {  72,2267 }, {  73,2267 },
 {  74,2267 }, {  75,2267 }, {  76,2267 }, {  77,2267 }, {  78,2267 },
 {  79,2267 }, {  80,2267 }, {  81,2267 }, {  82,2267 }, {  83,2267 },
 {  84,2267 }, {  85,2267 }, {  86,2267 }, {  87,2267 }, {  88,2267 },
 {  89,2267 }, {  90,2267 }, {  91,2267 }, {  92,2267 }, {  93,2267 },
 {  94,2267 }, {  95,2267 }, {   0,   0 }, {  97,2267 }, {  98,2267 },

 {  99,2267 }, { 100,2267 }, { 101,2267 }, { 102,2267 }, { 103,2267 },
 { 104,2267 }, { 105,2267 }, { 106,2267 }, { 107,2267 }, { 108,2267 },
 { 109,2267 }, { 110,2267 }, { 111,2267 }, { 112,2267 }, { 113,2267 },
 { 114,2267 }, { 115,2267 }, { 116,2267 }, { 117,2267 }, { 118,2267 },
 { 119,2267 }, { 120,2267 }, { 121,2267 }, { 122,2267 }, { 123,2267 },
 { 124,2267 }, { 125,2267 }, { 126,2267 }, { 127,2267 }, { 128,2267 },
 { 129,2267 }, { 130,2267 }, { 131,2267 }, { 132,2267 }, { 133,2267 },
 { 134,2267 }, { 135,2267 }, { 136,2267 }, { 137,2267 }, { 138,2267 },
 { 139,2267 }, { 140,2267 }, { 141,2267 }, { 142,2267 }, { 143,2267 },
 { 144,2267 }, { 145,2267 }, { 146,2267 }, { 147,2267 }, { 148,2267 },

 { 149,2267 }, { 150,2267 }, { 151,2267 }, { 152,2267 }, { 153,2267 },
 { 154,2267 }, { 155,2267 }, { 156,2267 }, { 157,2267 }, { 158,2267 },
 { 159,2267 }, { 160,2267 }, { 161,2267 }, { 162,2267 }, { 163,2267 },
 { 164,2267 }, { 165,2267 }, { 166,2267 }, { 167,2267 }, { 168,2267 },
 { 169,2267 }, { 170,2267 }, { 171,2267 }, { 172,2267 }, { 173,2267 },
 { 174,2267 }, { 175,2267 }, { 176,2267 }, { 177,2267 }, { 178,2267 },
 { 179,2267 }, { 180,2267 }, { 181,2267 }, { 182,2267 }, { 183,2267 },
 { 184,2267 }, { 185,2267 }, { 186,2267 }, { 187,2267 }, { 188,2267 },
 { 189,2267 }, { 190,2267 }, { 191,2267 }, { 192,2267 }, { 193,2267 },
 { 194,2267 }, { 195,2267 }, { 196,2267 }, { 197,2267 }, { 198,2267 },

 { 199,2267 }, { 200,2267 }, { 201,2267 }, { 202,2267 }, { 203,2267 },
 { 204,2267 }, { 205,2267 }, { 206,2267 }, { 207,2267 }, { 208,2267 },
 { 209,2267 }, { 210,2267 }, { 211,2267 }, { 212,2267 }, { 213,2267 },
 { 214,2267 }, { 215,2267 }, { 216,2267 }, { 217,2267 }, { 218,2267 },
 { 219,2267 }, { 220,2267 }, { 221,2267 }, { 222,2267 }, { 223,2267 },
 { 224,2267 }, { 225,2267 }, { 226,2267 }, { 227,2267 }, { 228,2267 },
 { 229,2267 }, { 230,2267 }, { 231,2267 }, { 232,2267 }, { 233,2267 },
 { 234,2267 }, { 235,2267 }, { 236,2267 }, { 237,2267 }, { 238,2267 },
 { 239,2267 }, { 240,2267 }, { 241,2267 }, { 242,2267 }, { 243,2267 },
 { 244,2267 }, { 245,2267 }, { 246,2267 }, { 247,2267 }, { 248,2267 },

 { 249,2267 }, { 250,2267 }, { 251,2267 }, { 252,2267 }, { 253,2267 },
 { 254,2267 }, { 255,2267 }, { 256,2267 }, {   0,   1 }, {   0,3792 },
 {   0,  31 }, {   0,3790 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   9,   0 }, {  10,   0 },
 {  11,   0 }, {  12,   0 }, {  13,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   3 }, {   0,3774 }, {   0,   4 }, {   0,3772 },
 {   0,  19 }, {   0,3770 }, {   0,  18 }, {   0,3768 }, {   0,  29 },
 {   0,3766 }, {   0,  11 }, {   0,3764 }, {   0,  20 }, {   0,3762 },
 {   0,   0 }, {  32,   0 }, {   0,  21 }, {   0,3758 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  36,2265 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,2265 },
 {  49,2265 }, {  50,2265 }, {  51,2265 }, {  52,2265 }, {  53,2265 },
 {  54,2265 }, {  55,2265 }, {  56,2265 }, {  57,2265 }, {  42,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  47,   2 },
 {   0,   0 }, {  65,2265 }, {  66,2265 }, {  67,2265 }, {  68,2265 },
 {  69,2265 }, {  70,2265 }, {  71,2265 }, {  72,2265 }, {  73,2265 },
 {  74,2265 }, {  75,2265 }, {  76,2265 }, {  77,2265 }, {  78,2265 },
 {  79,2265 }, {  80,2265 }, {  81,2265 }, {  82,2265 }, {  83,2265 },
 {  84,2265 }, {  85,2265 }, {  86,2265 }, {  87,2265 }, {  88,2265 },

 {  89,2265 }, {  90,2265 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  95,2265 }, {   0,   0 }, {  97,2265 }, {  98,2265 },
 {  99,2265 }, { 100,2265 }, { 101,2265 }, { 102,2265 }, { 103,2265 },
 { 104,2265 }, { 105,2265 }, { 106,2265 }, { 107,2265 }, { 108,2265 },
 { 109,2265 }, { 110,2265 }, { 111,2265 }, { 112,2265 }, { 113,2265 },
 { 114,2265 }, { 115,2265 }, { 116,2265 }, { 117,2265 }, { 118,2265 },
 { 119,2265 }, { 120,2265 }, { 121,2265 }, { 122,2265 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, { 128,2265 },
 { 129,2265 }, { 130,2265 }, { 131,2265 }, { 132,2265 }, { 133,2265 },
 { 134,2265 }, { 135,2265 }, { 136,2265 }, { 137,2265 }, { 138,2265 },

 { 139,2265 }, { 140,2265 }, { 141,2265 }, { 142,2265 }, { 143,2265 },
 { 144,2265 }, { 145,2265 }, { 146,2265 }, { 147,2265 }, { 148,2265 },
 { 149,2265 }, { 150,2265 }, { 151,2265 }, { 152,2265 }, { 153,2265 },
 { 154,2265 }, { 155,2265 }, { 156,2265 }, { 157,2265 }, { 158,2265 },
 { 159,2265 }, { 160,2265 }, { 161,2265 }, { 162,2265 }, { 163,2265 },
 { 164,2265 }, { 165,2265 }, { 166,2265 }, { 167,2265 }, { 168,2265 },
 { 169,2265 }, { 170,2265 }, { 171,2265 }, { 172,2265 }, { 173,2265 },
 { 174,2265 }, { 175,2265 }, { 176,2265 }, { 177,2265 }, { 178,2265 },
 { 179,2265 }, { 180,2265 }, { 181,2265 }, { 182,2265 }, { 183,2265 },
 { 184,2265 }, { 185,2265 }, { 186,2265 }, { 187,2265 }, { 188,2265 },

 { 189,2265 }, { 190,2265 }, { 191,2265 }, { 192,2265 }, { 193,2265 },
 { 194,2265 }, { 195,2265 }, { 196,2265 }, { 197,2265 }, { 198,2265 },
 { 199,2265 }, { 200,2265 }, { 201,2265 }, { 202,2265 }, { 203,2265 },
 { 204,2265 }, { 205,2265 }, { 206,2265 }, { 207,2265 }, { 208,2265 },
 { 209,2265 }, { 210,2265 }, { 211,2265 }, { 212,2265 }, { 213,2265 },
 { 214,2265 }, { 215,2265 }, { 216,2265 }, { 217,2265 }, { 218,2265 },
 { 219,2265 }, { 220,2265 }, { 221,2265 }, { 222,2265 }, { 223,2265 },
 { 224,2265 }, { 225,2265 }, { 226,2265 }, { 227,2265 }, { 228,2265 },
 { 229,2265 }, { 230,2265 }, { 231,2265 }, { 232,2265 }, { 233,2265 },
 { 234,2265 }, { 235,2265 }, { 236,2265 }, { 237,2265 }, { 238,2265 },

 { 239,2265 }, { 240,2265 }, { 241,2265 }, { 242,2265 }, { 243,2265 },
 { 244,2265 }, { 245,2265 }, { 246,2265 }, { 247,2265 }, { 248,2265 },
 { 249,2265 }, { 250,2265 }, { 251,2265 }, { 252,2265 }, { 253,2265 },
 { 254,2265 }, { 255,2265 }, {   0,   9 }, {   0,3533 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  69, 405 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   5 }, {   0,3445 }, {   1,2177 }, {   2,2177 }, {   3,2177 },
 {   4,2177 }, {   5,2177 }, {   6,2177 }, {   7,2177 }, {   8,2177 },
 {   9,2177 }, {   0,   0 }, {  11,2177 }, {  12,2177 }, { 101, 405 },
 {  14,2177 }, {  15,2177 }, {  16,2177 }, {  17,2177 }, {  18,2177 },
 {  19,2177 }, {  20,2177 }, {  21,2177 }, {  22,2177 }, {  23,2177 },
 {  24,2177 }, {  25,2177 }, {  26,2177 }, {  27,2177 }, {  28,2177 },
 {  29,2177 }, {  30,2177 }, {  31,2177 }, {  32,2177 }, {  33,2177 },
 {  34,2177 }, {  35,2177 }, {  36,2177 }, {  37,2177 }, {  38,2177 },
 {  39,2177 }, {  40,2177 }, {  41,2177 }, {  42,2177 }, {  43,2177 },

 {  44,2177 }, {  45,2177 }, {  46,2177 }, {  47,2177 }, {  48,2177 },
 {  49,2177 }, {  50,2177 }, {  51,2177 }, {  52,2177 }, {  53,2177 },
 {  54,2177 }, {  55,2177 }, {  56,2177 }, {  57,2177 }, {  58,2177 },
 {  59,2177 }, {  60,2177 }, {  61,2177 }, {  62,2177 }, {  63,2177 },
 {  64,2177 }, {  65,2177 }, {  66,2177 }, {  67,2177 }, {  68,2177 },
 {  69,2177 }, {  70,2177 }, {  71,2177 }, {  72,2177 }, {  73,2177 },
 {  74,2177 }, {  75,2177 }, {  76,2177 }, {  77,2177 }, {  78,2177 },
 {  79,2177 }, {  80,2177 }, {  81,2177 }, {  82,2177 }, {  83,2177 },
 {  84,2177 }, {  85,2177 }, {  86,2177 }, {  87,2177 }, {  88,2177 },
 {  89,2177 }, {  90,2177 }, {  91,2177 }, {  92,2177 }, {  93,2177 },

 {  94,2177 }, {  95,2177 }, {  96,2177 }, {  97,2177 }, {  98,2177 },
 {  99,2177 }, { 100,2177 }, { 101,2177 }, { 102,2177 }, { 103,2177 },
 { 104,2177 }, { 105,2177 }, { 106,2177 }, { 107,2177 }, { 108,2177 },
 { 109,2177 }, { 110,2177 }, { 111,2177 }, { 112,2177 }, { 113,2177 },
 { 114,2177 }, { 115,2177 }, { 116,2177 }, { 117,2177 }, { 118,2177 },
 { 119,2177 }, { 120,2177 }, { 121,2177 }, { 122,2177 }, { 123,2177 },
 { 124,2177 }, { 125,2177 }, { 126,2177 }, { 127,2177 }, { 128,2177 },
 { 129,2177 }, { 130,2177 }, { 131,2177 }, { 132,2177 }, { 133,2177 },
 { 134,2177 }, { 135,2177 }, { 136,2177 }, { 137,2177 }, { 138,2177 },
 { 139,2177 }, { 140,2177 }, { 141,2177 }, { 142,2177 }, { 143,2177 },

 { 144,2177 }, { 145,2177 }, { 146,2177 }, { 147,2177 }, { 148,2177 },
 { 149,2177 }, { 150,2177 }, { 151,2177 }, { 152,2177 }, { 153,2177 },
 { 154,2177 }, { 155,2177 }, { 156,2177 }, { 157,2177 }, { 158,2177 },
 { 159,2177 }, { 160,2177 }, { 161,2177 }, { 162,2177 }, { 163,2177 },
 { 164,2177 }, { 165,2177 }, { 166,2177 }, { 167,2177 }, { 168,2177 },
 { 169,2177 }, { 170,2177 }, { 171,2177 }, { 172,2177 }, { 173,2177 },
 { 174,2177 }, { 175,2177 }, { 176,2177 }, { 177,2177 }, { 178,2177 },
 { 179,2177 }, { 180,2177 }, { 181,2177 }, { 182,2177 }, { 183,2177 },
 { 184,2177 }, { 185,2177 }, { 186,2177 }, { 187,2177 }, { 188,2177 },
 { 189,2177 }, { 190,2177 }, { 191,2177 }, { 192,2177 }, { 193,2177 },

 { 194,2177 }, { 195,2177 }, { 196,2177 }, { 197,2177 }, { 198,2177 },
 { 199,2177 }, { 200,2177 }, { 201,2177 }, { 202,2177 }, { 203,2177 },
 { 204,2177 }, { 205,2177 }, { 206,2177 }, { 207,2177 }, { 208,2177 },
 { 209,2177 }, { 210,2177 }, { 211,2177 }, { 212,2177 }, { 213,2177 },
 { 214,2177 }, { 215,2177 }, { 216,2177 }, { 217,2177 }, { 218,2177 },
 { 219,2177 }, { 220,2177 }, { 221,2177 }, { 222,2177 }, { 223,2177 },
 { 224,2177 }, { 225,2177 }, { 226,2177 }, { 227,2177 }, { 228,2177 },
 { 229,2177 }, { 230,2177 }, { 231,2177 }, { 232,2177 }, { 233,2177 },
 { 234,2177 }, { 235,2177 }, { 236,2177 }, { 237,2177 }, { 238,2177 },
 { 239,2177 }, { 240,2177 }, { 241,2177 }, { 242,2177 }, { 243,2177 },

 { 244,2177 }, { 245,2177 }, { 246,2177 }, { 247,2177 }, { 248,2177 },
 { 249,2177 }, { 250,2177 }, { 251,2177 }, { 252,2177 }, { 253,2177 },
 { 254,2177 }, { 255,2177 }, { 256,2177 }, {   0,   9 }, {   0,3187 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   6 }, {   0,3165 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  46,-577 }, {   0,   0 }, {  48,2177 }, {  49,2177 }, {  50,2177 },
 {  51,2177 }, {  52,2177 }, {  53,2177 }, {  54,2177 }, {  55,2177 },
 {  56,2177 }, {  57,2177 }, {   0,  12 }, {   0,3128 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  46, -22 }, {  69,  59 }, {  48,   0 },
 {  49,   0 }, {  50,   0 }, {  51,   0 }, {  52,   0 }, {  53,   0 },
 {  54,   0 }, {  55,   0 }, {  56,   0 }, {  57,   0 }, {   0,   8 },
 {   0,3106 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  69,  37 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 { 101,  59 }, {  43,2128 }, {   0,   0 }, {  45,2128 }, {   0,   0 },
 {   0,   0 }, {  48,2140 }, {  49,2140 }, {  50,2140 }, {  51,2140 },
 {  52,2140 }, {  53,2140 }, {  54,2140 }, {  55,2140 }, {  56,2140 },
 {  57,2140 }, {   0,   0 }, {   0,  26 }, {   0,3068 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, { 101,  37 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,2133 }, {  49,2133 },
 {  50,2133 }, {  51,2133 }, {  52,2133 }, {  53,2133 }, {  54,2133 },

 {  55,2133 }, {  56,2133 }, {  57,2133 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  65,2133 }, {  66,2133 }, {  67,2133 }, {  68,2133 }, {  69,2133 },
 {  70,2133 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  36,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {   0,   0 }, {  97,2133 }, {  98,2133 }, {  99,2133 },
 { 100,2133 }, { 101,2133 }, { 102,2133 }, {  65,   0 }, {  66,   0 },

 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 },
 {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 },
 {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 },
 {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 },
 {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  95,   0 }, {   0,   0 },
 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },
 { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 },
 { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 },
 { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 },

 { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 },
 { 122,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 },
 { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 },
 { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 },
 { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 },
 { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 },
 { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 },
 { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 },
 { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 },

 { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 },
 { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 },
 { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 },
 { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 },
 { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 },
 { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 },
 { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 },
 { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 },
 { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 },
 { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 },

 { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 },
 { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 },
 { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 },
 { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 },
 { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 },
 { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 },
 { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 },
 { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 }, {   0,   3 },
 {   0,2811 }, {   1,   0 }, {   2,   0 }, {   3,   0 }, {   4,   0 },
 {   5,   0 }, {   6,   0 }, {   7,   0 }, {   8,   0 }, {   9,   0 },

 {  10,   0 }, {  11,   0 }, {  12,   0 }, {  13,   0 }, {  14,   0 },
 {  15,   0 }, {  16,   0 }, {  17,   0 }, {  18,   0 }, {  19,   0 },
 {  20,   0 }, {  21,   0 }, {  22,   0 }, {  23,   0 }, {  24,   0 },
 {  25,   0 }, {  26,   0 }, {  27,   0 }, {  28,   0 }, {  29,   0 },
 {  30,   0 }, {  31,   0 }, {  32,   0 }, {  33,   0 }, {  34,   0 },
 {  35,   0 }, {  36,   0 }, {  37,   0 }, {  38,   0 }, {  39,   0 },
 {  40,   0 }, {  41,   0 }, {   0,   0 }, {  43,   0 }, {  44,   0 },
 {  45,   0 }, {  46,   0 }, {  47,   0 }, {  48,   0 }, {  49,   0 },
 {  50,   0 }, {  51,   0 }, {  52,   0 }, {  53,   0 }, {  54,   0 },
 {  55,   0 }, {  56,   0 }, {  57,   0 }, {  58,   0 }, {  59,   0 },

 {  60,   0 }, {  61,   0 }, {  62,   0 }, {  63,   0 }, {  64,   0 },
 {  65,   0 }, {  66,   0 }, {  67,   0 }, {  68,   0 }, {  69,   0 },
 {  70,   0 }, {  71,   0 }, {  72,   0 }, {  73,   0 }, {  74,   0 },
 {  75,   0 }, {  76,   0 }, {  77,   0 }, {  78,   0 }, {  79,   0 },
 {  80,   0 }, {  81,   0 }, {  82,   0 }, {  83,   0 }, {  84,   0 },
 {  85,   0 }, {  86,   0 }, {  87,   0 }, {  88,   0 }, {  89,   0 },
 {  90,   0 }, {  91,   0 }, {  92,   0 }, {  93,   0 }, {  94,   0 },
 {  95,   0 }, {  96,   0 }, {  97,   0 }, {  98,   0 }, {  99,   0 },
 { 100,   0 }, { 101,   0 }, { 102,   0 }, { 103,   0 }, { 104,   0 },
 { 105,   0 }, { 106,   0 }, { 107,   0 }, { 108,   0 }, { 109,   0 },

 { 110,   0 }, { 111,   0 }, { 112,   0 }, { 113,   0 }, { 114,   0 },
 { 115,   0 }, { 116,   0 }, { 117,   0 }, { 118,   0 }, { 119,   0 },
 { 120,   0 }, { 121,   0 }, { 122,   0 }, { 123,   0 }, { 124,   0 },
 { 125,   0 }, { 126,   0 }, { 127,   0 }, { 128,   0 }, { 129,   0 },
 { 130,   0 }, { 131,   0 }, { 132,   0 }, { 133,   0 }, { 134,   0 },
 { 135,   0 }, { 136,   0 }, { 137,   0 }, { 138,   0 }, { 139,   0 },
 { 140,   0 }, { 141,   0 }, { 142,   0 }, { 143,   0 }, { 144,   0 },
 { 145,   0 }, { 146,   0 }, { 147,   0 }, { 148,   0 }, { 149,   0 },
 { 150,   0 }, { 151,   0 }, { 152,   0 }, { 153,   0 }, { 154,   0 },
 { 155,   0 }, { 156,   0 }, { 157,   0 }, { 158,   0 }, { 159,   0 },

 { 160,   0 }, { 161,   0 }, { 162,   0 }, { 163,   0 }, { 164,   0 },
 { 165,   0 }, { 166,   0 }, { 167,   0 }, { 168,   0 }, { 169,   0 },
 { 170,   0 }, { 171,   0 }, { 172,   0 }, { 173,   0 }, { 174,   0 },
 { 175,   0 }, { 176,   0 }, { 177,   0 }, { 178,   0 }, { 179,   0 },
 { 180,   0 }, { 181,   0 }, { 182,   0 }, { 183,   0 }, { 184,   0 },
 { 185,   0 }, { 186,   0 }, { 187,   0 }, { 188,   0 }, { 189,   0 },
 { 190,   0 }, { 191,   0 }, { 192,   0 }, { 193,   0 }, { 194,   0 },
 { 195,   0 }, { 196,   0 }, { 197,   0 }, { 198,   0 }, { 199,   0 },
 { 200,   0 }, { 201,   0 }, { 202,   0 }, { 203,   0 }, { 204,   0 },
 { 205,   0 }, { 206,   0 }, { 207,   0 }, { 208,   0 }, { 209,   0 },

 { 210,   0 }, { 211,   0 }, { 212,   0 }, { 213,   0 }, { 214,   0 },
 { 215,   0 }, { 216,   0 }, { 217,   0 }, { 218,   0 }, { 219,   0 },
 { 220,   0 }, { 221,   0 }, { 222,   0 }, { 223,   0 }, { 224,   0 },
 { 225,   0 }, { 226,   0 }, { 227,   0 }, { 228,   0 }, { 229,   0 },
 { 230,   0 }, { 231,   0 }, { 232,   0 }, { 233,   0 }, { 234,   0 },
 { 235,   0 }, { 236,   0 }, { 237,   0 }, { 238,   0 }, { 239,   0 },
 { 240,   0 }, { 241,   0 }, { 242,   0 }, { 243,   0 }, { 244,   0 },
 { 245,   0 }, { 246,   0 }, { 247,   0 }, { 248,   0 }, { 249,   0 },
 { 250,   0 }, { 251,   0 }, { 252,   0 }, { 253,   0 }, { 254,   0 },
 { 255,   0 }, { 256,   0 }, {   0,  16 }, {   0,2553 }, {   1,   0 },

 {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 }, {   6,   0 },
 {   7,   0 }, {   8,   0 }, {   9,   0 }, {  10,   0 }, {  11,   0 },
 {  12,   0 }, {  13,   0 }, {  14,   0 }, {  15,   0 }, {  16,   0 },
 {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 }, {  21,   0 },
 {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 }, {  26,   0 },
 {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 }, {  31,   0 },
 {  32,   0 }, {  33,   0 }, {   0,   0 }, {  35,   0 }, {  36,   0 },
 {  37,   0 }, {  38,   0 }, {  39,   0 }, {  40,   0 }, {  41,   0 },
 {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 }, {  46,   0 },
 {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },

 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {  58,   0 }, {  59,   0 }, {  60,   0 }, {  61,   0 },
 {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 }, {  66,   0 },
 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 },
 {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 },
 {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 },
 {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 },
 {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 }, {  91,   0 },
 {   0,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 }, {  96,   0 },
 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },

 { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 },
 { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 },
 { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 },
 { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 },
 { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 }, { 126,   0 },
 { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 },
 { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 },
 { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 },
 { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 },
 { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 },

 { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 },
 { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 },
 { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 },
 { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 },
 { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 },
 { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 },
 { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 },
 { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 },
 { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 },
 { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 },

 { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 },
 { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 },
 { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 },
 { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 },
 { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 },
 { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 },
 { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 },
 { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 },
 { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 },
 { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 },

 { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 }, { 256,   0 },
 {   0,  22 }, {   0,2295 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,  22 }, {   0,2272 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,1381 },
 {  49,1381 }, {  50,1381 }, {  51,1381 }, {  52,1381 }, {  53,1381 },
 {  54,1381 }, {  55,1381 }, {  56,1381 }, {  57,1381 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  65,1381 }, {  66,1381 }, {  67,1381 }, {  68,1381 },
 {  69,1381 }, {  70,1381 }, {  48,1381 }, {  49,1381 }, {  50,1381 },
 {  51,1381 }, {  52,1381 }, {  53,1381 }, {  54,1381 }, {  55,1381 },
 {  56,1381 }, {  57,1381 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65,1381 },
 {  66,1381 }, {  67,1381 }, {  68,1381 }, {  69,1381 }, {  70,1381 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97,1381 }, {  98,1381 },
 {  99,1381 }, { 100,1381 }, { 101,1381 }, { 102,1381 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  97,1381 }, {  98,1381 }, {  99,1381 }, { 100,1381 },
 { 101,1381 }, { 102,1381 }, {   0,  17 }, {   0,2168 }, {   1,   0 },
 {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 }, {   6,   0 },
 {   7,   0 }, {   8,   0 }, {   9,   0 }, {  10,   0 }, {  11,   0 },
 {  12,   0 }, {  13,   0 }, {  14,   0 }, {  15,   0 }, {  16,   0 },

 {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 }, {  21,   0 },
 {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 }, {  26,   0 },
 {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 }, {  31,   0 },
 {  32,   0 }, {  33,   0 }, {  34,   0 }, {  35,   0 }, {  36,   0 },
 {  37,   0 }, {  38,   0 }, {   0,   0 }, {  40,   0 }, {  41,   0 },
 {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 }, {  46,   0 },
 {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {  58,   0 }, {  59,   0 }, {  60,   0 }, {  61,   0 },
 {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 }, {  66,   0 },

 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 },
 {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 },
 {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 },
 {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 },
 {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 }, {  91,   0 },
 {   0,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 }, {  96,   0 },
 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },
 { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 },
 { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 },
 { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 },

 { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 },
 { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 }, { 126,   0 },
 { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 },
 { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 },
 { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 },
 { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 },
 { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 },
 { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 },
 { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 },
 { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 },

 { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 },
 { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 },
 { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 },
 { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 },
 { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 },
 { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 },
 { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 },
 { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 },
 { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 },
 { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 },

 { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 },
 { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 },
 { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 },
 { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 },
 { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 },
 { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 },
 { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 },
 { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 }, { 256,   0 },
 {   0,  22 }, {   0,1910 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,  22 }, {   0,1887 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,1057 },
 {  49,1057 }, {  50,1057 }, {  51,1057 }, {  52,1057 }, {  53,1057 },
 {  54,1057 }, {  55,1057 }, {  56,1057 }, {  57,1057 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  65,1057 }, {  66,1057 }, {  67,1057 }, {  68,1057 },
 {  69,1057 }, {  70,1057 }, {  48,1057 }, {  49,1057 }, {  50,1057 },
 {  51,1057 }, {  52,1057 }, {  53,1057 }, {  54,1057 }, {  55,1057 },
 {  56,1057 }, {  57,1057 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65,1057 },
 {  66,1057 }, {  67,1057 }, {  68,1057 }, {  69,1057 }, {  70,1057 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97,1057 }, {  98,1057 },
 {  99,1057 }, { 100,1057 }, { 101,1057 }, { 102,1057 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  97,1057 }, {  98,1057 }, {  99,1057 }, { 100,1057 },
 { 101,1057 }, { 102,1057 }, {   0,  28 }, {   0,1783 }, {   1,   0 },
 {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 }, {   6,   0 },
 {   7,   0 }, {   8,   0 }, {   9,   0 }, {  10,   0 }, {  11,   0 },
 {  12,   0 }, {  13,   0 }, {  14,   0 }, {  15,   0 }, {  16,   0 },
 {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 }, {  21,   0 },
 {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 }, {  26,   0 },
 {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 }, {  31,   0 },

 {  32,   0 }, {  33,   0 }, {  34,   0 }, {  35,   0 }, {  36,   0 },
 {  37,   0 }, {  38,   0 }, {  39,   0 }, {  40,   0 }, {  41,   0 },
 {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 }, {  46,   0 },
 {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {  58,   0 }, {  59,   0 }, {  60,   0 }, {  61,   0 },
 {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 }, {  66,   0 },
 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 },
 {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 },
 {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 },

 {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 },
 {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 }, {  91,   0 },
 {  92,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 }, {   0,   0 },
 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },
 { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 },
 { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 },
 { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 },
 { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 },
 { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 }, { 126,   0 },
 { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 },

 { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 },
 { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 },
 { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 },
 { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 },
 { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 },
 { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 },
 { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 },
 { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 },
 { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 },
 { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 },

 { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 },
 { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 },
 { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 },
 { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 },
 { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 },
 { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 },
 { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 },
 { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 },
 { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 },
 { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 },

 { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 },
 { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 },
 { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 },
 { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 },
 { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 }, { 256,   0 },
 {   0,  31 }, {   0,1525 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  36,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,   0 },
 {  49,   0 }, {  50,   0 }, {  51,   0 }, {  52,   0 }, {  53,   0 },
 {  54,   0 }, {  55,   0 }, {  56,   0 }, {  57,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  65,   0 }, {  66,   0 }, {  67,   0 }, {  68,   0 },
 {  69,   0 }, {  70,   0 }, {  71,   0 }, {  72,   0 }, {  73,   0 },

 {  74,   0 }, {  75,   0 }, {  76,   0 }, {  77,   0 }, {  78,   0 },
 {  79,   0 }, {  80,   0 }, {  81,   0 }, {  82,   0 }, {  83,   0 },
 {  84,   0 }, {  85,   0 }, {  86,   0 }, {  87,   0 }, {  88,   0 },
 {  89,   0 }, {  90,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  95,   0 }, {   0,   0 }, {  97,   0 }, {  98,   0 },
 {  99,   0 }, { 100,   0 }, { 101,   0 }, { 102,   0 }, { 103,   0 },
 { 104,   0 }, { 105,   0 }, { 106,   0 }, { 107,   0 }, { 108,   0 },
 { 109,   0 }, { 110,   0 }, { 111,   0 }, { 112,   0 }, { 113,   0 },
 { 114,   0 }, { 115,   0 }, { 116,   0 }, { 117,   0 }, { 118,   0 },
 { 119,   0 }, { 120,   0 }, { 121,   0 }, { 122,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, { 128,   0 },
 { 129,   0 }, { 130,   0 }, { 131,   0 }, { 132,   0 }, { 133,   0 },
 { 134,   0 }, { 135,   0 }, { 136,   0 }, { 137,   0 }, { 138,   0 },
 { 139,   0 }, { 140,   0 }, { 141,   0 }, { 142,   0 }, { 143,   0 },
 { 144,   0 }, { 145,   0 }, { 146,   0 }, { 147,   0 }, { 148,   0 },
 { 149,   0 }, { 150,   0 }, { 151,   0 }, { 152,   0 }, { 153,   0 },
 { 154,   0 }, { 155,   0 }, { 156,   0 }, { 157,   0 }, { 158,   0 },
 { 159,   0 }, { 160,   0 }, { 161,   0 }, { 162,   0 }, { 163,   0 },
 { 164,   0 }, { 165,   0 }, { 166,   0 }, { 167,   0 }, { 168,   0 },
 { 169,   0 }, { 170,   0 }, { 171,   0 }, { 172,   0 }, { 173,   0 },

 { 174,   0 }, { 175,   0 }, { 176,   0 }, { 177,   0 }, { 178,   0 },
 { 179,   0 }, { 180,   0 }, { 181,   0 }, { 182,   0 }, { 183,   0 },
 { 184,   0 }, { 185,   0 }, { 186,   0 }, { 187,   0 }, { 188,   0 },
 { 189,   0 }, { 190,   0 }, { 191,   0 }, { 192,   0 }, { 193,   0 },
 { 194,   0 }, { 195,   0 }, { 196,   0 }, { 197,   0 }, { 198,   0 },
 { 199,   0 }, { 200,   0 }, { 201,   0 }, { 202,   0 }, { 203,   0 },
 { 204,   0 }, { 205,   0 }, { 206,   0 }, { 207,   0 }, { 208,   0 },
 { 209,   0 }, { 210,   0 }, { 211,   0 }, { 212,   0 }, { 213,   0 },
 { 214,   0 }, { 215,   0 }, { 216,   0 }, { 217,   0 }, { 218,   0 },
 { 219,   0 }, { 220,   0 }, { 221,   0 }, { 222,   0 }, { 223,   0 },

 { 224,   0 }, { 225,   0 }, { 226,   0 }, { 227,   0 }, { 228,   0 },
 { 229,   0 }, { 230,   0 }, { 231,   0 }, { 232,   0 }, { 233,   0 },
 { 234,   0 }, { 235,   0 }, { 236,   0 }, { 237,   0 }, { 238,   0 },
 { 239,   0 }, { 240,   0 }, { 241,   0 }, { 242,   0 }, { 243,   0 },
 { 244,   0 }, { 245,   0 }, { 246,   0 }, { 247,   0 }, { 248,   0 },
 { 249,   0 }, { 250,   0 }, { 251,   0 }, { 252,   0 }, { 253,   0 },
 { 254,   0 }, { 255,   0 }, {   0,   5 }, {   0,1268 }, {   1,   0 },
 {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 }, {   6,   0 },
 {   7,   0 }, {   8,   0 }, {   9,   0 }, {   0,   0 }, {  11,   0 },
 {  12,   0 }, {   0,   0 }, {  14,   0 }, {  15,   0 }, {  16,   0 },

 {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 }, {  21,   0 },
 {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 }, {  26,   0 },
 {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 }, {  31,   0 },
 {  32,   0 }, {  33,   0 }, {  34,   0 }, {  35,   0 }, {  36,   0 },
 {  37,   0 }, {  38,   0 }, {  39,   0 }, {  40,   0 }, {  41,   0 },
 {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 }, {  46,   0 },
 {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {  58,   0 }, {  59,   0 }, {  60,   0 }, {  61,   0 },
 {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 }, {  66,   0 },

 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 },
 {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 },
 {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 },
 {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 },
 {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 }, {  91,   0 },
 {  92,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 }, {  96,   0 },
 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },
 { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 },
 { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 },
 { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 },

 { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 },
 { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 }, { 126,   0 },
 { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 },
 { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 },
 { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 },
 { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 },
 { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 },
 { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 },
 { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 },
 { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 },

 { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 },
 { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 },
 { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 },
 { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 },
 { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 },
 { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 },
 { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 },
 { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 },
 { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 },
 { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 },

 { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 },
 { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 },
 { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 },
 { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 },
 { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 },
 { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 },
 { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 },
 { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 }, { 256,   0 },
 {   0,   9 }, {   0,1010 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,  13 }, {   0,1000 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,  10 }, {   0, 988 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   7 }, {   0, 973 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,   0 },
 {  49,   0 }, {  50,   0 }, {  51,   0 }, {  52,   0 }, {  53,   0 },
 {  54,   0 }, {  55,   0 }, {  56,   0 }, {  57,   0 }, {  48,  12 },

 {  49,  12 }, {  50,  12 }, {  51,  12 }, {  52,  12 }, {  53,  12 },
 {  54,  12 }, {  55,  12 }, {  56,  12 }, {  57,  12 }, {   0,   0 },
 {  69,-2118 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {   0,  22 }, {   0, 914 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, { 101,-2118 }, {  65,   0 }, {  66,   0 },
 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,  22 },
 {   0, 891 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },
 { 102,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  48, 143 }, {  49, 143 }, {  50, 143 }, {  51, 143 }, {  52, 143 },
 {  53, 143 }, {  54, 143 }, {  55, 143 }, {  56, 143 }, {  57, 143 },
 {   0,   0 }, {   0,   0 }, {   0,  22 }, {   0, 853 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {  65, 143 }, {  66, 143 }, {  67, 143 },
 {  68, 143 }, {  69, 143 }, {  70, 143 }, {  48, 143 }, {  49, 143 },
 {  50, 143 }, {  51, 143 }, {  52, 143 }, {  53, 143 }, {  54, 143 },
 {  55, 143 }, {  56, 143 }, {  57, 143 }, {   0,   0 }, {   0,   0 },
 {   0,  22 }, {   0, 830 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  65, 143 }, {  66, 143 }, {  67, 143 }, {  68, 143 }, {  69, 143 },
 {  70, 143 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97, 143 },
 {  98, 143 }, {  99, 143 }, { 100, 143 }, { 101, 143 }, { 102, 143 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  48, 143 }, {  49, 143 }, {  50, 143 }, {  51, 143 },

 {  52, 143 }, {  53, 143 }, {  54, 143 }, {  55, 143 }, {  56, 143 },
 {  57, 143 }, {   0,   0 }, {  97, 143 }, {  98, 143 }, {  99, 143 },
 { 100, 143 }, { 101, 143 }, { 102, 143 }, {  65, 143 }, {  66, 143 },
 {  67, 143 }, {  68, 143 }, {  69, 143 }, {  70, 143 }, {  48, 143 },
 {  49, 143 }, {  50, 143 }, {  51, 143 }, {  52, 143 }, {  53, 143 },
 {  54, 143 }, {  55, 143 }, {  56, 143 }, {  57, 143 }, {   0,  22 },
 {   0, 771 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  65, 143 }, {  66, 143 }, {  67, 143 }, {  68, 143 },
 {  69, 143 }, {  70, 143 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  97, 143 }, {  98, 143 }, {  99, 143 }, { 100, 143 }, { 101, 143 },

 { 102, 143 }, {   0,   0 }, {   0,  22 }, {   0, 748 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97, 143 }, {  98, 143 },
 {  99, 143 }, { 100, 143 }, { 101, 143 }, { 102, 143 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48, 143 }, {  49, 143 },
 {  50, 143 }, {  51, 143 }, {  52, 143 }, {  53, 143 }, {  54, 143 },
 {  55, 143 }, {  56, 143 }, {  57, 143 }, {   0,   0 }, {   0,   0 },
 {   0,  22 }, {   0, 710 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  65, 143 }, {  66, 143 }, {  67, 143 }, {  68, 143 }, {  69, 143 },

 {  70, 143 }, {  48, 143 }, {  49, 143 }, {  50, 143 }, {  51, 143 },
 {  52, 143 }, {  53, 143 }, {  54, 143 }, {  55, 143 }, {  56, 143 },
 {  57, 143 }, {   0,   0 }, {   0,   0 }, {   0,  22 }, {   0, 687 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65, 143 }, {  66, 143 },
 {  67, 143 }, {  68, 143 }, {  69, 143 }, {  70, 143 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  97, 143 }, {  98, 143 }, {  99, 143 },
 { 100, 143 }, { 101, 143 }, { 102, 143 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48, 143 },
 {  49, 143 }, {  50, 143 }, {  51, 143 }, {  52, 143 }, {  53, 143 },
 {  54, 143 }, {  55, 143 }, {  56, 143 }, {  57, 143 }, {   0,   0 },

 {  97, 143 }, {  98, 143 }, {  99, 143 }, { 100, 143 }, { 101, 143 },
 { 102, 143 }, {  65, 143 }, {  66, 143 }, {  67, 143 }, {  68, 143 },
 {  69, 143 }, {  70, 143 }, {  48, 143 }, {  49, 143 }, {  50, 143 },
 {  51, 143 }, {  52, 143 }, {  53, 143 }, {  54, 143 }, {  55, 143 },
 {  56, 143 }, {  57, 143 }, {   0,  22 }, {   0, 628 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65, 143 },
 {  66, 143 }, {  67, 143 }, {  68, 143 }, {  69, 143 }, {  70, 143 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97, 143 }, {  98, 143 },
 {  99, 143 }, { 100, 143 }, { 101, 143 }, { 102, 143 }, {   0,   0 },
 {   0,  22 }, {   0, 605 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  97, 143 }, {  98, 143 }, {  99, 143 }, { 100, 143 },
 { 101, 143 }, { 102, 143 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  48, 143 }, {  49, 143 }, {  50, 143 }, {  51, 143 },
 {  52, 143 }, {  53, 143 }, {  54, 143 }, {  55, 143 }, {  56, 143 },
 {  57, 143 }, {   0,   0 }, {   0,   0 }, {   0,  22 }, {   0, 567 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65, 143 }, {  66, 143 },
 {  67, 143 }, {  68, 143 }, {  69, 143 }, {  70, 143 }, {  48,-3157 },
 {  49,-3157 }, {  50,-3157 }, {  51,-3157 }, {  52,-3157 }, {  53,-3157 },

 {  54,-3157 }, {  55,-3157 }, {  56,-3157 }, {  57,-3157 }, {   0,   0 },
 {   0,   0 }, {   0,  22 }, {   0, 544 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  65,-3157 }, {  66,-3157 }, {  67,-3157 }, {  68,-3157 },
 {  69,-3157 }, {  70,-3157 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  97, 143 }, {  98, 143 }, {  99, 143 }, { 100, 143 }, { 101, 143 },
 { 102, 143 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  48, 105 }, {  49, 105 }, {  50, 105 },
 {  51, 105 }, {  52, 105 }, {  53, 105 }, {  54, 105 }, {  55, 105 },
 {  56, 105 }, {  57, 105 }, {   0,   0 }, {  97,-3157 }, {  98,-3157 },
 {  99,-3157 }, { 100,-3157 }, { 101,-3157 }, { 102,-3157 }, {  65, 105 },

 {  66, 105 }, {  67, 105 }, {  68, 105 }, {  69, 105 }, {  70, 105 },
 {  48,-3214 }, {  49,-3214 }, {  50,-3214 }, {  51,-3214 }, {  52,-3214 },
 {  53,-3214 }, {  54,-3214 }, {  55,-3214 }, {  56,-3214 }, {  57,-3214 },
 {   0,  22 }, {   0, 485 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  65,-3214 }, {  66,-3214 }, {  67,-3214 },
 {  68,-3214 }, {  69,-3214 }, {  70,-3214 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  97, 105 }, {  98, 105 }, {  99, 105 }, { 100, 105 },
 { 101, 105 }, { 102, 105 }, {   0,   0 }, {   0,  22 }, {   0, 462 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97,-3214 },
 {  98,-3214 }, {  99,-3214 }, { 100,-3214 }, { 101,-3214 }, { 102,-3214 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,  61 },
 {  49,  61 }, {  50,  61 }, {  51,  61 }, {  52,  61 }, {  53,  61 },
 {  54,  61 }, {  55,  61 }, {  56,  61 }, {  57,  61 }, {   0,   0 },
 {   0,   0 }, {   0,  22 }, {   0, 424 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  65,  61 }, {  66,  61 }, {  67,  61 }, {  68,  61 },
 {  69,  61 }, {  70,  61 }, {  48,  61 }, {  49,  61 }, {  50,  61 },
 {  51,  61 }, {  52,  61 }, {  53,  61 }, {  54,  61 }, {  55,  61 },
 {  56,  61 }, {  57,  61 }, {   0,   0 }, {   0,   0 }, {   0,  22 },

 {   0, 401 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65,  61 },
 {  66,  61 }, {  67,  61 }, {  68,  61 }, {  69,  61 }, {  70,  61 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97,  61 }, {  98,  61 },
 {  99,  61 }, { 100,  61 }, { 101,  61 }, { 102,  61 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  48,  82 }, {  49,  82 }, {  50,  82 }, {  51,  82 }, {  52,  82 },
 {  53,  82 }, {  54,  82 }, {  55,  82 }, {  56,  82 }, {  57,  82 },
 {   0,   0 }, {  97,  61 }, {  98,  61 }, {  99,  61 }, { 100,  61 },
 { 101,  61 }, { 102,  61 }, {  65,  82 }, {  66,  82 }, {  67,  82 },
 {  68,  82 }, {  69,  82 }, {  70,  82 }, {  48,  82 }, {  49,  82 },

 {  50,  82 }, {  51,  82 }, {  52,  82 }, {  53,  82 }, {  54,  82 },
 {  55,  82 }, {  56,  82 }, {  57,  82 }, {   0,  22 }, {   0, 342 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  65,  82 }, {  66,  82 }, {  67,  82 }, {  68,  82 }, {  69,  82 },
 {  70,  82 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97,  82 },
 {  98,  82 }, {  99,  82 }, { 100,  82 }, { 101,  82 }, { 102,  82 },
 {   0,   0 }, {   0,  22 }, {   0, 319 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  97,  82 }, {  98,  82 }, {  99,  82 },

 { 100,  82 }, { 101,  82 }, { 102,  82 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  48,  61 }, {  49,  61 }, {  50,  61 },
 {  51,  61 }, {  52,  61 }, {  53,  61 }, {  54,  61 }, {  55,  61 },
 {  56,  61 }, {  57,  61 }, {   0,   0 }, {   0,   0 }, {   0,  22 },
 {   0, 281 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65,  61 },
 {  66,  61 }, {  67,  61 }, {  68,  61 }, {  69,  61 }, {  70,  61 },
 {  48,  61 }, {  49,  61 }, {  50,  61 }, {  51,  61 }, {  52,  61 },
 {  53,  61 }, {  54,  61 }, {  55,  61 }, {  56,  61 }, {  57,  61 },
 {   0,   0 }, {   0,   0 }, {   0,  22 }, {   0, 258 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  65,  61 }, {  66,  61 }, {  67,  61 },

 {  68,  61 }, {  69,  61 }, {  70,  61 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  97,  61 }, {  98,  61 }, {  99,  61 }, { 100,  61 },
 { 101,  61 }, { 102,  61 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  48,-3481 }, {  49,-3481 },
 {  50,-3481 }, {  51,-3481 }, {  52,-3481 }, {  53,-3481 }, {  54,-3481 },
 {  55,-3481 }, {  56,-3481 }, {  57,-3481 }, {   0,   0 }, {  97,  61 },
 {  98,  61 }, {  99,  61 }, { 100,  61 }, { 101,  61 }, { 102,  61 },
 {  65,-3481 }, {  66,-3481 }, {  67,-3481 }, {  68,-3481 }, {  69,-3481 },
 {  70,-3481 }, {  48,-3500 }, {  49,-3500 }, {  50,-3500 }, {  51,-3500 },
 {  52,-3500 }, {  53,-3500 }, {  54,-3500 }, {  55,-3500 }, {  56,-3500 },

 {  57,-3500 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  65,-3500 }, {  66,-3500 },
 {  67,-3500 }, {  68,-3500 }, {  69,-3500 }, {  70,-3500 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  97,-3481 }, {  98,-3481 }, {  99,-3481 },
 { 100,-3481 }, { 101,-3481 }, { 102,-3481 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  97,-3500 }, {  98,-3500 }, {  99,-3500 }, { 100,-3500 }, { 101,-3500 },
 { 102,-3500 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 { 257,  42 }, {   1,   0 },    };

static yyconst struct yy_trans_info *yy_start_state_list[13] =
    {
    &yy_transition[1],
    &yy_transition[3],
    &yy_transition[261],
    &yy_transition[519],
    &yy_transition[777],
    &yy_transition[1035],
    &yy_transition[1293],
    &yy_transition[1551],
    &yy_transition[1809],
    &yy_transition[2067],
    &yy_transition[2325],
    &yy_transition[2583],
    &yy_transition[2841],

    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#line 1 "src/backend/parser/ag_scanner.l"

#define YY_NO_UNISTD_H 1
/* to override the default memory management */
/* remove warnings */
#define YY_NO_INPUT 1
/* remove unneeded routines */
/*
 * whitespace rule in Cypher handles twenty-four characters out of the
 * twenty-five characters defined as whitespace characters, four extra control
 * characters (FS, GS, RS, and US), and Mongolian vowel separator in Unicode.
 *
 * Only six of them below have been considered as whitespace characters here.
 * This character set is a superset of whitespace characters in JSON.
 *
 *     [\t\n\v\f\r ]
 *         U+0009 CHARACTER TABULATION (HT, Horizontal Tab)
 *         U+000A LINE FEED (LF)
 *         U+000B LINE TABULATION (VT, Vertical Tab)
 *         U+000C FORM FEED (FF)
 *         U+000D CARRIAGE RETURN (CR)
 *         U+0020 SPACE
 *
 * The other characters are listed below for future reference. To handle them,
 * you may use the patterns that match UTF-8 encoded code points of them.
 *
 *     \xC2[\x85\xA0]
 *         U+0085 NEXT LINE (NEL) -- not in Cypher
 *         U+00A0 NO-BREAK SPACE
 *     \xE1\x9A\x80
 *         U+1680 OGHAM SPACE MARK
 *     \xE2\x80[\x80-\x8A\xA8\xA9\xAF]
 *         U+2000 EN QUAD
 *         U+2001 EM QUAD
 *         U+2002 EN SPACE
 *         U+2003 EM SPACE
 *         U+2004 THREE-PER-EM SPACE
 *         U+2005 FOUR-PER-EM SPACE
 *         U+2006 SIX-PER-EM SPACE
 *         U+2007 FIGURE SPACE
 *         U+2008 PUNCTUATION SPACE
 *         U+2009 THIN SPACE
 *         U+200A HAIR SPACE
 *         U+2028 LINE SEPARATOR
 *         U+2029 PARAGRAPH SEPARATOR
 *         U+202F NARROW NO-BREAK SPACE
 *     \xE2\x81\x9F
 *         U+205F MEDIUM MATHEMATICAL SPACE
 *     \xE3\x80\x80
 *         U+3000 IDEOGRAPHIC SPACE
 *
 *     [\x1C-\x1F]
 *         U+001C INFORMATION SEPARATOR FOUR (FS, File Separator)
 *         U+001D INFORMATION SEPARATOR THREE (GS, Group Separator)
 *         U+001E INFORMATION SEPARATOR TWO (RS, Record Separator)
 *         U+001F INFORMATION SEPARATOR ONE (US, Unit Separator)
 *
 *     \xE1\xA0\x8E
 *         U+180E MONGOLIAN VOWEL SEPARATOR -- not a whitespace anymore
 */
/*
 * Comment rule for multi-line comment in Cypher does not match comments that
 * end with an odd number of "*"s before the closing sequence.
 * Therefore, the rule has been modified so that it can match such comments.
 */

/*
 * For numbers, unary plus and minus are handled as operators later in Cypher
 * grammar although JSON numbers may be prefixed with an optional minus sign.
 *
 * JSON does not support octal and hexadecimal integer literals.
 */
/*
 * digitseq pattern covers DecimalInteger and OctalInteger rules in Cypher.
 * Integer in JSON is represented in "0|[1-9][0-9]*" pattern that is covered by
 * digitseq pattern.
 */
/*
 * hexint pattern covers HexInteger rule in Cypher and also accepts "0X" prefix
 * for convenience.
 */
/*
 * decimal pattern covers RegularDecimalReal rule in Cypher and also accepts
 * "{digitseq}\." pattern (e.g. "1.") which RegularDecimalReal rule doesn't.
 * Decimal in JSON is represented in "(0|[1-9][0-9]*)\.[0-9]+" pattern that is
 * covered by decimal pattern.
 *
 * decimalfail pattern is for ranges (e.g. "0..1"). The action for the pattern
 * consumes digitseq and returns dot_dot back to the input stream so that
 * dot_dot can be matched next.
 */
/*
 * decimalsci pattern covers ExponentDecimalReal rule in Cypher. It also
 * accepts coefficients in "{digitseq}\." pattern and explicit positive
 * exponents ("+") which ExponentDecimalReal rule doesn't.
 * Scientific notation in JSON is represented in
 * "(0|[1-9][0-9]*)(\.[0-9]+)?[Ee][+-]?[0-9]+" pattern that is covered by
 * decimalsci pattern.
 */
/*
 * These patterns cover StringLiteral rule in Cypher and JSON strings.
 * The escape sequence "\/" has been added for JSON strings.
 *
 * esasciifail and esunicodefail patterns handle escape sequences that are not
 * accepted by esascii and esunicode patterns respectively.
 *
 * Since esasciifail pattern can match anything that esascii pattern can,
 * esascii must appear first before esasciifail in the rules section.
 *
 * qstru start condition is for Unicode low surrogates.
 */

/* id pattern is for UnescapedSymbolicName rule in Cypher. */
/* These are for EscapedSymbolicName rule in Cypher. */

/*
 * Parameter rule in Cypher is "$" followed by SymbolicName or DecimalInteger
 * rule. However, according to "Cypher Query Language Reference",
 *
 *     Parameters may consist of letters and numbers, and any combination of
 *     these, but cannot start with a number or a currency symbol.
 *
 * So, a modified version of Parameter rule that follows the above explanation
 * has been used.
 */
/*
 * These are tokens that are used as operators and language constructs in
 * Cypher, and some of them are structural characters in JSON.
 */
#line 242 "src/backend/parser/ag_scanner.l"
typedef struct strbuf
{
    char *buffer;
    int capacity;
    int length;
} strbuf;

static void strbuf_init(strbuf *sb, int capacity);
static void strbuf_cleanup(strbuf *sb);
static void strbuf_append_buf(strbuf *sb, const char *b, const int len);
static void strbuf_append_char(strbuf *sb, const char c);
static void strbuf_append_codepoint(strbuf *sb, const pg_wchar c);
static void strbuf_ensure_capacity(strbuf *sb, int len);
static const char *strbuf_get_str(strbuf *sb);
static void strbuf_reset(strbuf *sb);

typedef struct ag_yy_extra
{
    /*
     * accumulate matched strings to build a complete literal if multiple rules
     * are needed to scan it, or keep a decimal integer literal that is
     * converted from a hexadecimal or an octal integer literal if it is too
     * large to fit in "int" type
     */
    strbuf literal_buf;

    // for Unicode surrogate pair
    pg_wchar high_surrogate;
    int start_cond;

    // for the location of the current token and the actual position of it
    const char *scan_buf;
    int last_loc;
} ag_yy_extra;

static void integer_literal_to_token(const char *s, ag_token *token,
                                     ag_yy_extra *extra);
#define hexadecimal_to_decimal(numstr, sb) _numstr_to_decimal(numstr, 16, sb)
#define octal_to_decimal(numstr, sb) _numstr_to_decimal(numstr, 8, sb)
static void _numstr_to_decimal(const char *numstr, const int base, strbuf *sb);
static uint32 hexdigit_value(const char c);
static uint32 octdigit_value(const char c);

static bool is_high_surrogate(const pg_wchar c);
static bool is_low_surrogate(const pg_wchar c);
static pg_wchar surrogate_pair_to_codepoint(const pg_wchar hi,
                                            const pg_wchar lo);

#define update_location() \
    do \
    { \
        yyextra.last_loc = yytext - yyextra.scan_buf; \
    } while (0)
#define get_location() (yyextra.last_loc)

#define scan_errmsg(msg) _scan_errmsg(msg, &yyextra)
static int _scan_errmsg(const char *msg, const ag_yy_extra *extra);
#define scan_errposition() _scan_errposition(yyextra.last_loc, &yyextra)
static int _scan_errposition(const int location, const ag_yy_extra *extra);

/*
 * Avoid exit() on fatal scanner errors.
 * Call yy_fatal_error() just to keep compiler quiet.
 */
#define YY_FATAL_ERROR(msg) \
    do \
    { \
        ereport(ERROR, (errmsg_internal("%s", msg))); \
        yy_fatal_error(NULL, NULL); \
    } while (0)

/*
 * "yyscanner" must be used for the name of the parameter because it is
 * referenced internally. "yyscan_t" is OK because it is actually "void *"
 * and is the same with "ag_scanner_t".
 */
#define YY_DECL ag_token ag_scanner_next_token(yyscan_t yyscanner)
#line 2565 "src/backend/parser/ag_scanner.c"

#define INITIAL 0
#define mlcomment 1
#define dqstr 2
#define sqstr 3
#define qstru 4
#define bqid 5

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#define YY_EXTRA_TYPE ag_yy_extra

/* Holds the entire state of the reentrant scanner. */
struct yyguts_t
    {

    /* User-defined. Not touched by flex. */
    YY_EXTRA_TYPE yyextra_r;

    /* The rest are the same as the globals declared in the non-reentrant scanner. */
    FILE *yyin_r, *yyout_r;
    size_t yy_buffer_stack_top; /**< index of top of stack. */
    size_t yy_buffer_stack_max; /**< capacity of stack. */
    YY_BUFFER_STATE * yy_buffer_stack; /**< Stack as an array. */
    char yy_hold_char;
    int yy_n_chars;
    int yyleng_r;
    char *yy_c_buf_p;
    int yy_init;
    int yy_start;
    int yy_did_buffer_switch_on_eof;
    int yy_start_stack_ptr;
    int yy_start_stack_depth;
    int *yy_start_stack;
    yy_state_type yy_last_accepting_state;
    char* yy_last_accepting_cpos;

    int yylineno_r;
    int yy_flex_debug_r;

    char *yytext_r;
    int yy_more_flag;
    int yy_more_len;

    }; /* end struct yyguts_t */

static int yy_init_globals (yyscan_t yyscanner );

int ag_yylex_init (yyscan_t* scanner);

int ag_yylex_init_extra (YY_EXTRA_TYPE user_defined,yyscan_t* scanner);

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int ag_yylex_destroy (yyscan_t yyscanner );

YY_EXTRA_TYPE ag_yyget_extra (yyscan_t yyscanner );

void ag_yyset_extra (YY_EXTRA_TYPE user_defined ,yyscan_t yyscanner );

int ag_yyget_column  (yyscan_t yyscanner );

void ag_yyset_column (int _column_no ,yyscan_t yyscanner );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int ag_yywrap (yyscan_t yyscanner );
#else
extern int ag_yywrap (yyscan_t yyscanner );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int ,yyscan_t yyscanner);
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * ,yyscan_t yyscanner);
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (yyscan_t yyscanner );
#else
static int input (yyscan_t yyscanner );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg , yyscanner)
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int ag_yylex (yyscan_t yyscanner);

#define YY_DECL int ag_yylex (yyscan_t yyscanner)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( !yyg->yy_init )
		{
		yyg->yy_init = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yyg->yy_start )
			yyg->yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			ag_yyensure_buffer_stack (yyscanner);
			YY_CURRENT_BUFFER_LVALUE =
				ag_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
		}

		ag_yy_load_buffer_state(yyscanner );
		}

	{
#line 321 "src/backend/parser/ag_scanner.l"



// This is used in the actions below.
ag_token token;


#line 2815 "src/backend/parser/ag_scanner.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yyg->yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yyg->yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start_state_list[yyg->yy_start];
yy_match:
		{
		yyconst struct yy_trans_info *yy_trans_info;

		YY_CHAR yy_c;

		for ( yy_c = YY_SC_TO_UI(*yy_cp);
		      (yy_trans_info = &yy_current_state[(unsigned int) yy_c])->
		yy_verify == yy_c;
		      yy_c = YY_SC_TO_UI(*++yy_cp) )
			yy_current_state += yy_trans_info->yy_nxt;
		}

yy_find_action:
		yy_act = yy_current_state[-1].yy_nxt;

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 328 "src/backend/parser/ag_scanner.l"
{
    // ignore
}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 332 "src/backend/parser/ag_scanner.l"
{
    // update location in case of unterminated comment
    update_location();
    BEGIN(mlcomment);
}
	YY_BREAK
case 3:
/* rule 3 can match eol */
YY_RULE_SETUP
#line 338 "src/backend/parser/ag_scanner.l"
{
    // ignore
}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 342 "src/backend/parser/ag_scanner.l"
{
    BEGIN(INITIAL);
}
	YY_BREAK
case YY_STATE_EOF(mlcomment):
#line 346 "src/backend/parser/ag_scanner.l"
{
    ereport(ERROR, (errcode(ERRCODE_SYNTAX_ERROR),
                    scan_errmsg("unterminated /* comment"),
                    scan_errposition()));
}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 352 "src/backend/parser/ag_scanner.l"
{
    // ignore
}
	YY_BREAK
case 6:
#line 357 "src/backend/parser/ag_scanner.l"
case 7:
YY_RULE_SETUP
#line 357 "src/backend/parser/ag_scanner.l"
{
    update_location();
    integer_literal_to_token(yytext, &token, &yyextra);
    token.location = get_location();
    return token;
}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 364 "src/backend/parser/ag_scanner.l"
{
    update_location();
    ereport(ERROR, (errcode(ERRCODE_SYNTAX_ERROR),
                    scan_errmsg("invalid hexadecimal integer literal"),
                    scan_errposition()));
}
	YY_BREAK
case 9:
#line 372 "src/backend/parser/ag_scanner.l"
case 10:
YY_RULE_SETUP
#line 372 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_DECIMAL;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 380 "src/backend/parser/ag_scanner.l"
{
    // return dot_dot back to the input stream
    yyless(yyleng - 2);

    update_location();

    // consume digitseq
    integer_literal_to_token(yytext, &token, &yyextra);
    token.location = get_location();
    return token;
}
	YY_BREAK
case 12:
#line 393 "src/backend/parser/ag_scanner.l"
case 13:
YY_RULE_SETUP
#line 393 "src/backend/parser/ag_scanner.l"
{
    update_location();
    ereport(ERROR, (errcode(ERRCODE_SYNTAX_ERROR),
                    scan_errmsg("invalid scientific notation literal"),
                    scan_errposition()));
}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 400 "src/backend/parser/ag_scanner.l"
{
    update_location();
    strbuf_reset(&yyextra.literal_buf);
    BEGIN(dqstr);
}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 406 "src/backend/parser/ag_scanner.l"
{
    update_location();
    strbuf_reset(&yyextra.literal_buf);
    BEGIN(sqstr);
}
	YY_BREAK
case 16:
/* rule 16 can match eol */
#line 413 "src/backend/parser/ag_scanner.l"
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 413 "src/backend/parser/ag_scanner.l"
{
    strbuf_append_buf(&yyextra.literal_buf, yytext, yyleng);
}
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 417 "src/backend/parser/ag_scanner.l"
{
    char c;

    switch (yytext[1])
    {
    case 'b':
        c = '\b';
        break;
    case 'f':
        c = '\f';
        break;
    case 'n':
        c = '\n';
        break;
    case 'r':
        c = '\r';
        break;
    case 't':
        c = '\t';
        break;
    default:
        // '"', '\'', '/', and '\\'
        c = yytext[1];
        break;
    }

    strbuf_append_char(&yyextra.literal_buf, c);
}
	YY_BREAK
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 446 "src/backend/parser/ag_scanner.l"
{
    if (yyleng == 1)
    {
        /*
         * This happens when the scanner meets "\"<<EOF>>. Just consume "\"
         * so that <dqstr,sqstr,qstru><<EOF>> rule can do the rest.
         */
        strbuf_append_char(&yyextra.literal_buf, '\\');
    }
    else
    {
        update_location();
        ereport(ERROR,
                (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
                 scan_errmsg("invalid escape sequence"),
                 errdetail("Valid escape sequences are \\\", \\', \\/, \\\\, \\b, \\f, \\n, \\r, \\t, \\uXXXX, and \\UXXXXXXXX."),
                 scan_errposition()));
    }
}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 466 "src/backend/parser/ag_scanner.l"
{
    pg_wchar c;

    // It is unnecessary to check endptr and errno here.
    c = strtoul(yytext + 2, NULL, 16);
    if (c > 0x10FFFF)
    {
        // c is greater than the maximum value of a Unicode code point.
        update_location();
        ereport(ERROR,
                (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
                 scan_errmsg("invalid Unicode escape value"),
                 errdetail("Unicode escape values cannot be greater than 10FFFF, which is the maximum value of a code point."),
                 scan_errposition()));
    }
    else if (c > 0x7F)
    {
        if (GetDatabaseEncoding() != PG_UTF8)
        {
            update_location();
            ereport(ERROR,
                    (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
                     scan_errmsg("unsupported Unicode escape value"),
                     errdetail("Unicode escape values cannot be used for code point values above 007F when the server encoding is not UTF8."),
                     scan_errposition()));
        }

        if (is_high_surrogate(c))
        {
            yyextra.high_surrogate = c;
            yyextra.start_cond = YY_START;
            BEGIN(qstru);
        }
        else if (is_low_surrogate(c))
        {
            update_location();
            ereport(ERROR,
                    (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
                     scan_errmsg("invalid Unicode surrogate pair"),
                     errdetail("A low surrogate must follow a high surrogate."),
                     scan_errposition()));
        }
        else
        {
            strbuf_append_codepoint(&yyextra.literal_buf, c);
        }
    }
    else if (c > 0)
    {
        // c is an ASCII character.
        strbuf_append_char(&yyextra.literal_buf, (char)c);
    }
    else
    {
        /*
         * U+0000 NUL is the minimum value of a Unicode code point.
         * However, it is invalid in quoted strings as well as query strings.
         */
        update_location();
        ereport(ERROR,
                (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
                 scan_errmsg("unsupported Unicode escape value"),
                 errdetail("Unicode code point value 0000 is not allowed in quoted strings."),
                 scan_errposition()));
    }
}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 533 "src/backend/parser/ag_scanner.l"
{
    pg_wchar c;

    c = strtoul(yytext + 2, NULL, 16);
    if (is_low_surrogate(c))
    {
        c = surrogate_pair_to_codepoint(yyextra.high_surrogate, c);
        // 0x010000 <= c <= 0x10FFFF always holds for surrogate pairs.
        strbuf_append_codepoint(&yyextra.literal_buf, c);
        BEGIN(yyextra.start_cond);
    }
    else
    {
        update_location();
        ereport(ERROR,
                (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
                 scan_errmsg("invalid Unicode surrogate pair"),
                 errdetail("A low surrogate must follow a high surrogate."),
                 scan_errposition()));
    }
}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 555 "src/backend/parser/ag_scanner.l"
{
    update_location();
    ereport(ERROR,
            (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
             scan_errmsg("invalid Unicode escape sequence"),
             errhint("Unicode escape sequences must be \\uXXXX or \\UXXXXXXXX."),
             scan_errposition()));
}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 564 "src/backend/parser/ag_scanner.l"
{
    update_location();
    ereport(ERROR, (errcode(ERRCODE_INVALID_ESCAPE_SEQUENCE),
                    scan_errmsg("invalid Unicode surrogate pair"),
                    errdetail("A low surrogate must follow a high surrogate."),
                    scan_errposition()));
}
	YY_BREAK
case 24:
#line 573 "src/backend/parser/ag_scanner.l"
case 25:
YY_RULE_SETUP
#line 573 "src/backend/parser/ag_scanner.l"
{
    BEGIN(INITIAL);

    /*
     * In quoted strings, only Unicode escape sequences need to be verified,
     * and the actions for <dqstr,sqstr>{esunicode} and <qstru>{esunicode}
     * rules verify the code point values. So, quoted strings are always valid.
     */

    token.type = AG_TOKEN_STRING;
    token.value.s = strbuf_get_str(&yyextra.literal_buf);
    token.location = get_location();
    return token;
}
	YY_BREAK
case YY_STATE_EOF(dqstr):
case YY_STATE_EOF(sqstr):
case YY_STATE_EOF(qstru):
#line 588 "src/backend/parser/ag_scanner.l"
{
    ereport(ERROR, (errcode(ERRCODE_SYNTAX_ERROR),
                    scan_errmsg("unterminated quoted string"),
                    scan_errposition()));
}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 594 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_IDENTIFIER;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 602 "src/backend/parser/ag_scanner.l"
{
    update_location();
    strbuf_reset(&yyextra.literal_buf);
    BEGIN(bqid);
}
	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 608 "src/backend/parser/ag_scanner.l"
{
    strbuf_append_buf(&yyextra.literal_buf, yytext, yyleng);
}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 612 "src/backend/parser/ag_scanner.l"
{
    strbuf_append_char(&yyextra.literal_buf, '`');
}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 616 "src/backend/parser/ag_scanner.l"
{
    BEGIN(INITIAL);

    if (yyextra.literal_buf.length == 0)
    {
        ereport(ERROR, (errcode(ERRCODE_INVALID_NAME),
                        scan_errmsg("zero-length quoted identifier"),
                        scan_errposition()));
    }

    token.type = AG_TOKEN_IDENTIFIER;
    token.value.s = strbuf_get_str(&yyextra.literal_buf);
    token.location = get_location();
    return token;
}
	YY_BREAK
case YY_STATE_EOF(bqid):
#line 632 "src/backend/parser/ag_scanner.l"
{
    ereport(ERROR, (errcode(ERRCODE_SYNTAX_ERROR),
                    scan_errmsg("unterminated quoted identifier"),
                    scan_errposition()));
}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 638 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_PARAMETER;
    token.value.s = yytext + 1;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 646 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_LT_GT;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 654 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_LT_EQ;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 662 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_GT_EQ;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 670 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_DOT_DOT;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 678 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_PLUS_EQ;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 686 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_EQ_TILDE;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 694 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_TYPECAST;
    token.value.s = yytext;
    token.location = get_location();
    return token;
}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 702 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_CHAR;
    token.value.c = yytext[0];
    token.location = get_location();
    return token;
}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 710 "src/backend/parser/ag_scanner.l"
{
    update_location();
    ereport(ERROR, (errcode(ERRCODE_SYNTAX_ERROR),
                    scan_errmsg("unexpected character"),
                    scan_errposition()));
}
	YY_BREAK
case YY_STATE_EOF(INITIAL):
#line 717 "src/backend/parser/ag_scanner.l"
{
    update_location();
    token.type = AG_TOKEN_NULL;
    token.value.c = '\0';
    token.location = get_location();
    return token;
}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 725 "src/backend/parser/ag_scanner.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 3380 "src/backend/parser/ag_scanner.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yyg->yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yyg->yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * ag_yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yyg->yy_c_buf_p <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yyg->yy_c_buf_p = yyg->yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state( yyscanner );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state , yyscanner);

			yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yyg->yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yyg->yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer( yyscanner ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yyg->yy_did_buffer_switch_on_eof = 0;

				if ( ag_yywrap(yyscanner ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yyg->yy_c_buf_p = yyg->yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yyg->yy_c_buf_p =
					yyg->yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yyg->yy_c_buf_p =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars];

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of ag_yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = yyg->yytext_ptr;
	yy_size_t number_to_move, i;
	int ret_val;

	if ( yyg->yy_c_buf_p > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yyg->yy_c_buf_p - yyg->yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (yy_size_t) (yyg->yy_c_buf_p - yyg->yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) (yyg->yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					ag_yyrealloc((void *) b->yy_ch_buf,(yy_size_t) (b->yy_buf_size + 2) ,yyscanner );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yyg->yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			yyg->yy_n_chars, num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	if ( yyg->yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			ag_yyrestart(yyin  ,yyscanner);
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((int) (yyg->yy_n_chars + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = yyg->yy_n_chars + number_to_move + (yyg->yy_n_chars >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) ag_yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,(yy_size_t) new_size ,yyscanner );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	yyg->yy_n_chars += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yyg->yytext_ptr = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (yyscan_t yyscanner)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	yy_current_state = yy_start_state_list[yyg->yy_start];

	for ( yy_cp = yyg->yytext_ptr + YY_MORE_ADJ; yy_cp < yyg->yy_c_buf_p; ++yy_cp )
		{
		yy_current_state += yy_current_state[(*yy_cp ? YY_SC_TO_UI(*yy_cp) : 256)].yy_nxt;
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state , yyscan_t yyscanner)
{
	int yy_is_jam;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner; /* This var may be unused depending upon options. */

	int yy_c = 256;
	yyconst struct yy_trans_info *yy_trans_info;

	yy_trans_info = &yy_current_state[(unsigned int) yy_c];
	yy_current_state += yy_trans_info->yy_nxt;
	yy_is_jam = (yy_trans_info->yy_verify != yy_c);

	(void)yyg;
	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (yyscan_t yyscanner)
#else
    static int input  (yyscan_t yyscanner)
#endif

{
	int c;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	*yyg->yy_c_buf_p = yyg->yy_hold_char;

	if ( *yyg->yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yyg->yy_c_buf_p < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			/* This was really a NUL. */
			*yyg->yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yyg->yy_c_buf_p - yyg->yytext_ptr;
			++yyg->yy_c_buf_p;

			switch ( yy_get_next_buffer( yyscanner ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					ag_yyrestart(yyin ,yyscanner);

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( ag_yywrap(yyscanner ) )
						return 0;

					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput(yyscanner);
#else
					return input(yyscanner);
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yyg->yy_c_buf_p = yyg->yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yyg->yy_c_buf_p;	/* cast for 8-bit char's */
	*yyg->yy_c_buf_p = '\0';	/* preserve yytext */
	yyg->yy_hold_char = *++yyg->yy_c_buf_p;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * @param yyscanner The scanner object.
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void ag_yyrestart  (FILE * input_file , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! YY_CURRENT_BUFFER ){
        ag_yyensure_buffer_stack (yyscanner);
		YY_CURRENT_BUFFER_LVALUE =
            ag_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
	}

	ag_yy_init_buffer(YY_CURRENT_BUFFER,input_file ,yyscanner);
	ag_yy_load_buffer_state(yyscanner );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * @param yyscanner The scanner object.
 */
    void ag_yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	/* TODO. We should be able to replace this entire function body
	 * with
	 *		ag_yypop_buffer_state();
	 *		ag_yypush_buffer_state(new_buffer);
     */
	ag_yyensure_buffer_stack (yyscanner);
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	ag_yy_load_buffer_state(yyscanner );

	/* We don't actually know whether we did this switch during
	 * EOF (ag_yywrap()) processing, but the only time this flag
	 * is looked at is after ag_yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yyg->yy_did_buffer_switch_on_eof = 1;
}

static void ag_yy_load_buffer_state  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	yyg->yytext_ptr = yyg->yy_c_buf_p = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	yyg->yy_hold_char = *yyg->yy_c_buf_p;
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * @param yyscanner The scanner object.
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE ag_yy_create_buffer  (FILE * file, int  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) ag_yyalloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in ag_yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) ag_yyalloc((yy_size_t) (b->yy_buf_size + 2) ,yyscanner );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in ag_yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	ag_yy_init_buffer(b,file ,yyscanner);

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with ag_yy_create_buffer()
 * @param yyscanner The scanner object.
 */
    void ag_yy_delete_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		ag_yyfree((void *) b->yy_ch_buf ,yyscanner );

	ag_yyfree((void *) b ,yyscanner );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a ag_yyrestart() or at EOF.
 */
    static void ag_yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file , yyscan_t yyscanner)

{
	int oerrno = errno;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	ag_yy_flush_buffer(b ,yyscanner);

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then ag_yy_init_buffer was _probably_
     * called from ag_yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * @param yyscanner The scanner object.
 */
    void ag_yy_flush_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		ag_yy_load_buffer_state(yyscanner );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  @param yyscanner The scanner object.
 */
void ag_yypush_buffer_state (YY_BUFFER_STATE new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (new_buffer == NULL)
		return;

	ag_yyensure_buffer_stack(yyscanner);

	/* This block is copied from ag_yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		yyg->yy_buffer_stack_top++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from ag_yy_switch_to_buffer. */
	ag_yy_load_buffer_state(yyscanner );
	yyg->yy_did_buffer_switch_on_eof = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  @param yyscanner The scanner object.
 */
void ag_yypop_buffer_state (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (!YY_CURRENT_BUFFER)
		return;

	ag_yy_delete_buffer(YY_CURRENT_BUFFER ,yyscanner);
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if (yyg->yy_buffer_stack_top > 0)
		--yyg->yy_buffer_stack_top;

	if (YY_CURRENT_BUFFER) {
		ag_yy_load_buffer_state(yyscanner );
		yyg->yy_did_buffer_switch_on_eof = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void ag_yyensure_buffer_stack (yyscan_t yyscanner)
{
	int num_to_alloc;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if (!yyg->yy_buffer_stack) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		yyg->yy_buffer_stack = (struct yy_buffer_state**)ag_yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in ag_yyensure_buffer_stack()" );
								  
		memset(yyg->yy_buffer_stack, 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		yyg->yy_buffer_stack_max = num_to_alloc;
		yyg->yy_buffer_stack_top = 0;
		return;
	}

	if (yyg->yy_buffer_stack_top >= (yyg->yy_buffer_stack_max) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = yyg->yy_buffer_stack_max + grow_size;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)ag_yyrealloc
								(yyg->yy_buffer_stack,
								num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in ag_yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset(yyg->yy_buffer_stack + yyg->yy_buffer_stack_max, 0, grow_size * sizeof(struct yy_buffer_state*));
		yyg->yy_buffer_stack_max = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE ag_yy_scan_buffer  (char * base, yy_size_t  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) ag_yyalloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in ag_yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	ag_yy_switch_to_buffer(b ,yyscanner );

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (yyconst char* msg , yyscan_t yyscanner)
{
	struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	(void)yyg;
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        yy_size_t yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = yyg->yy_hold_char; \
		yyg->yy_c_buf_p = yytext + yyless_macro_arg; \
		yyg->yy_hold_char = *yyg->yy_c_buf_p; \
		*yyg->yy_c_buf_p = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the user-defined data for this scanner.
 * @param yyscanner The scanner object.
 */
YY_EXTRA_TYPE ag_yyget_extra  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyextra;
}

/** Get the current column number.
 * @param yyscanner The scanner object.
 */
int ag_yyget_column  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    
        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yycolumn;
}

/** Get the current token.
 * @param yyscanner The scanner object.
 */

/** Set the user-defined data. This data is never touched by the scanner.
 * @param user_defined The data to be associated with this scanner.
 * @param yyscanner The scanner object.
 */
void ag_yyset_extra (YY_EXTRA_TYPE  user_defined , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyextra = user_defined ;
}

/** Set the current column.
 * @param _column_no column number
 * @param yyscanner The scanner object.
 */
void ag_yyset_column (int  _column_no , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* column is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           YY_FATAL_ERROR( "ag_yyset_column called with no buffer" );
    
    yycolumn = _column_no;
}

/* Accessor methods for yylval and yylloc */

/* User-visible API */

/* ag_yylex_init is special because it creates the scanner itself, so it is
 * the ONLY reentrant function that doesn't take the scanner as the last argument.
 * That's why we explicitly handle the declaration, instead of using our macros.
 */

int ag_yylex_init(yyscan_t* ptr_yy_globals)

{
    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }

    *ptr_yy_globals = (yyscan_t) ag_yyalloc ( sizeof( struct yyguts_t ), NULL );

    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }

    /* By setting to 0xAA, we expose bugs in yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));

    return yy_init_globals ( *ptr_yy_globals );
}

/* ag_yylex_init_extra has the same functionality as ag_yylex_init, but follows the
 * convention of taking the scanner as the last argument. Note however, that
 * this is a *pointer* to a scanner, as it will be allocated by this call (and
 * is the reason, too, why this function also must handle its own declaration).
 * The user defined value in the first argument will be available to ag_yyalloc in
 * the yyextra field.
 */

int ag_yylex_init_extra(YY_EXTRA_TYPE yy_user_defined,yyscan_t* ptr_yy_globals )

{
    struct yyguts_t dummy_yyguts;

    ag_yyset_extra (yy_user_defined, &dummy_yyguts);

    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }
	
    *ptr_yy_globals = (yyscan_t) ag_yyalloc ( sizeof( struct yyguts_t ), &dummy_yyguts );
	
    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }
    
    /* By setting to 0xAA, we expose bugs in
    yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));
    
    ag_yyset_extra (yy_user_defined, *ptr_yy_globals);
    
    return yy_init_globals ( *ptr_yy_globals );
}

static int yy_init_globals (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from ag_yylex_destroy(), so don't allocate here.
     */

    yyg->yy_buffer_stack = NULL;
    yyg->yy_buffer_stack_top = 0;
    yyg->yy_buffer_stack_max = 0;
    yyg->yy_c_buf_p = NULL;
    yyg->yy_init = 0;
    yyg->yy_start = 0;

    yyg->yy_start_stack_ptr = 0;
    yyg->yy_start_stack_depth = 0;
    yyg->yy_start_stack =  NULL;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * ag_yylex_init()
     */
    return 0;
}

/* ag_yylex_destroy is for both reentrant and non-reentrant scanners. */
int ag_yylex_destroy  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		ag_yy_delete_buffer(YY_CURRENT_BUFFER ,yyscanner );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		ag_yypop_buffer_state(yyscanner);
	}

	/* Destroy the stack itself. */
	ag_yyfree(yyg->yy_buffer_stack ,yyscanner);
	yyg->yy_buffer_stack = NULL;

    /* Destroy the start condition stack. */
        ag_yyfree(yyg->yy_start_stack ,yyscanner );
        yyg->yy_start_stack = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * ag_yylex() is called, initialization will occur. */
    yy_init_globals( yyscanner);

    /* Destroy the main struct (reentrant only). */
    ag_yyfree ( yyscanner , yyscanner );
    yyscanner = NULL;
    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n , yyscan_t yyscanner)
{
	struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	(void)yyg;

	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s , yyscan_t yyscanner)
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

#define YYTABLES_NAME "yytables"

#line 725 "src/backend/parser/ag_scanner.l"



/*
 * Override the default memory management to make flex use palloc() instead of
 * malloc().
 */

void *ag_yyalloc(yy_size_t size, yyscan_t yyscanner)
{
    return palloc(size);
}

void *ag_yyrealloc(void *ptr, yy_size_t size, yyscan_t yyscanner)
{
    // see realloc(3)
    if (ptr)
    {
        if (size == 0)
        {
            pfree(ptr);
            return NULL;
        }
        else
        {
            return repalloc(ptr, size);
        }
    }
    else
    {
        return palloc(size);
    }
}

void ag_yyfree(void *ptr, yyscan_t yyscanner)
{
    if (ptr)
        pfree(ptr);
}

static void strbuf_init(strbuf *sb, int capacity)
{
    sb->buffer = palloc(capacity);
    sb->capacity = capacity;
    sb->length = 0;
}

static void strbuf_cleanup(strbuf *sb)
{
    if (sb->buffer)
        pfree(sb->buffer);
}

static void strbuf_append_buf(strbuf *sb, const char *b, const int len)
{
    strbuf_ensure_capacity(sb, sb->length + len);
    memcpy(sb->buffer + sb->length, b, len);
    sb->length += len;
}

static void strbuf_append_char(strbuf *sb, const char c)
{
    strbuf_ensure_capacity(sb, sb->length + 1);
    sb->buffer[sb->length] = c;
    sb->length += 1;
}

static void strbuf_append_codepoint(strbuf *sb, const pg_wchar c)
{
    unsigned char buf[6];

    unicode_to_utf8(c, buf);
    strbuf_append_buf(sb, (char *)buf, pg_utf_mblen(buf));
}

/*
 * len cannot be greater than MaxAllocSize because ReadCommand() reads
 * a message and places the message body in StringInfo.
 */
static void strbuf_ensure_capacity(strbuf *sb, int len)
{
    // consider additional 1 byte for the last '\0' character
    if (len < sb->capacity)
        return;

    do
    {
        sb->capacity *= 2;
    } while (sb->capacity <= len);

    sb->buffer = repalloc(sb->buffer, sb->capacity);
}

static const char *strbuf_get_str(strbuf *sb)
{
    sb->buffer[sb->length] = '\0';
    return sb->buffer;
}

static void strbuf_reset(strbuf *sb)
{
    sb->length = 0;
}

static void integer_literal_to_token(const char *s, ag_token *token,
                                     ag_yy_extra *extra)
{
    char *endptr;
    int i;

    errno = 0;
    i = strtoint(s, &endptr, 0);

    /*
     * This is only needed for invalid octal integer literals. (e.g. "08")
     * Other cases cannot happen because of digitseq and hexint rules.
     */
    if (*endptr != '\0')
    {
        ereport(ERROR, (errcode(ERRCODE_SYNTAX_ERROR),
                        _scan_errmsg("invalid octal integer literal", extra),
                        _scan_errposition(extra->last_loc, extra)));
    }

    // Treat it as a decimal if it is too large to be an "int" value.
    if (errno == ERANGE)
    {
        /*
         * Accessing s[0] and s[1] is safe because ERANGE is returned only if
         * there are 10 or more characters in s. In this case, the shortest
         * integer literals for decimal, hexadecimal, and octal integers are
         * "2147483648", "0x80000000", and "020000000000" respectively.
         */
        if (s[0] == '0')
        {
            strbuf_reset(&extra->literal_buf);

            /*
             * No matter how many characters s has, if all digits in s are
             * zeros, strtoint() returns 0 without an error.
             * So, _numstr_to_decimal() assumes that there is at least one
             * non-zero digit in s.
             */
            if (s[1] == 'X' || s[1] == 'x')
                hexadecimal_to_decimal(s + 2, &extra->literal_buf);
            else
                octal_to_decimal(s + 1, &extra->literal_buf);

            s = strbuf_get_str(&extra->literal_buf);
        }
        token->type = AG_TOKEN_DECIMAL;
        token->value.s = s;
        return;
    }

    token->type = AG_TOKEN_INTEGER;
    token->value.i = i;
}

/*
 * convert a string of a hexadecimal or an octal integer to a string of the
 * corresponding decimal integer
 */
static void _numstr_to_decimal(const char *numstr, const int base, strbuf *sb)
{
    // constants for each base
    int ndigits_per_word;
    int nbits_per_digit;
    uint32 (*digit_value)(const char);

    /*
     * constants for the conversion
     *
     *     "divisor" is 10^9.
     *
     *     At most 3 divisions are needed to eliminate 1 word.
     *         hex: 4294967295999999999 -> 4294967295 -> 4 -> 0
     *         oct: 1073741823999999999 -> 1073741823 -> 1 -> 0
     */
    const uint64 divisor = 1000000000;
    const int ndivisions = 3;
    const int ndigits_per_remainder = 9;

    int ndigits;
    int nwords;
    uint32 *words;
    const char *digitp;
    int word_i;
    int ndigits_word0;
    uint32 word;
    uint32 *remainders;
    int nremainders;
    int i;

    // set constants for each base
    switch (base)
    {
    case 16:
        /*
         * Hexadecimal
         *
         * Maximum value for each word
         *     0xFFFFFFFF = 4294967295
         * Divisor
         *     0x3B9ACA00 = 1000000000
         * Maximum remainder
         *     0x3B9AC9FF = 999999999
         *
         * Maximum dividend
         *     0x3B9AC9FFFFFFFFFF = 4294967295999999999
         * Quotient of the maximum dividend and the divisor
         *     0xFFFFFFFF = 4294967295
         * Remainer of the above division
         *     0x3B9AC9FF = 999999999
         */
        ndigits_per_word = 8;
        nbits_per_digit = 4;
        digit_value = hexdigit_value;
        break;
    case 8:
        /*
         * Octal
         *
         * Maximum value for each word
         *     07777777777 = 1073741823
         * Divisor
         *     07346545000 = 1000000000
         * Maximum remainder
         *     07346544777 = 999999999
         *
         * Maximum dividend
         *     073465447777777777777 = 1073741823999999999
         * Quotient of the maximum dividend and the divisor
         *     07777777777 = 1073741823
         * Remainer of the above division
         *     07346544777 = 999999999
         */
        ndigits_per_word = 10;
        nbits_per_digit = 3;
        digit_value = octdigit_value;
        break;
    default:
        Assert(!"invalid base");
        return;
    }

    // skip leading zeros
    while (*numstr == '0')
        numstr++;

    // number of digits in "numstr"
    ndigits = strlen(numstr);
    Assert(ndigits > 0);

    // prepare "words" to store "numstr" in two's complement representation
    nwords = (ndigits + (ndigits_per_word - 1)) / ndigits_per_word;
    words = palloc(sizeof(*words) * nwords);

    digitp = numstr;
    word_i = 0;

    // number of digits for the first word
    ndigits_word0 = ndigits % ndigits_per_word;
    if (ndigits_word0 == 0)
        ndigits_word0 = ndigits_per_word;

    // fill the first word
    word = digit_value(*digitp++);
    for (i = 1; i < ndigits_word0; i++)
    {
        word <<= nbits_per_digit;
        word |= digit_value(*digitp++);
    }
    words[word_i++] = word;

    // fill the rest of "words"
    while (word_i < nwords)
    {
        word = digit_value(*digitp++);
        for (i = 1; i < ndigits_per_word; i++)
        {
            word <<= nbits_per_digit;
            word |= digit_value(*digitp++);
        }
        words[word_i++] = word;
    }

    // At most "ndivisions" divisions are needed to eliminate 1 word.
    remainders = palloc(sizeof(*remainders) * (ndivisions * nwords));

    nremainders = 0;
    word_i = 0;
    // repeat dividing "words" by "divisor" until the quotient becomes 0
    while (word_i < nwords)
    {
        uint64 r;

        r = 0;
        // divide "words" by "divisor"
        for (i = word_i; i < nwords; i++)
        {
            uint64 d;
            uint64 q;

            d = (uint64)words[i];
            d |= r << (nbits_per_digit * ndigits_per_word);

            q = d / divisor;
            r = d % divisor;

            words[i] = (uint32)q;
        }

        // collect the remainder to build the result
        remainders[nremainders++] = (uint32)r;

        /*
         * Divisions over the first effective word is done
         * and "words" is getting closer to 0.
         */
        if (words[word_i] == 0)
            word_i++;
    }

    // convert the collected remainders to a string, starting from the last one
    for (i = nremainders - 1; i >= 0; i--)
    {
        char buf[ndigits_per_remainder];
        int buf_i;
        uint32 tmp;

        buf_i = ndigits_per_remainder;

        for (tmp = remainders[i]; tmp > 0; tmp /= 10)
            buf[--buf_i] = '0' + (char)(tmp % 10);

        // leading zeros for intermediate digits
        if (i < nremainders - 1)
        {
            while (buf_i > 0)
                buf[--buf_i] = '0';
        }

        strbuf_append_buf(sb, &buf[buf_i], ndigits_per_remainder - buf_i);
    }

    pfree(remainders);
    pfree(words);
}

static uint32 hexdigit_value(const char c)
{
    if (c >= '0' && c <= '9')
        return c - '0';

    if (c >= 'A' && c <= 'F')
        return 0xA + (c - 'A');

    Assert(c >= 'a' && c <= 'f');
    return 0xA + (c - 'a');
}

static uint32 octdigit_value(const char c)
{
    Assert(c >= '0' && c <= '7');
    return c - '0';
}

static bool is_high_surrogate(const pg_wchar c)
{
    return (c >= 0xD800 && c <= 0xDBFF);
}

static bool is_low_surrogate(const pg_wchar c)
{
    return (c >= 0xDC00 && c <= 0xDFFF);
}

// http://www.unicode.org/faq/utf_bom.html#utf16-4
static pg_wchar surrogate_pair_to_codepoint(const pg_wchar hi,
                                            const pg_wchar lo)
{
    const pg_wchar surrogate_offset = 0x10000 - (0xD800 << 10) - 0xDC00;

    return (hi << 10) + lo + surrogate_offset;
}

static int _scan_errmsg(const char *msg, const ag_yy_extra *extra)
{
    const char *t = extra->scan_buf + extra->last_loc;

    if (t[0] == YY_END_OF_BUFFER_CHAR)
        return errmsg("%s at end of input", msg);
    else
        return errmsg("%s at or near \"%s\"", msg, t);
}

static int _scan_errposition(const int location, const ag_yy_extra *extra)
{
    int pos;

    // no-op if location is unknown
    if (location < 0)
        return 0;

    // convert byte offset to number of characters
    pos = pg_mbstrlen_with_len(extra->scan_buf, location) + 1;

    return errposition(pos);
}

ag_scanner_t ag_scanner_create(const char *s)
{
    Size len;
    char *buf;
    yyscan_t yyscanner;
    ag_yy_extra extra;
    int ret;

    // The last two YY_END_OF_BUFFER_CHAR are required by flex.
    len = strlen(s);
    buf = palloc(len + 2);
    memcpy(buf, s, len);
    buf[len] = YY_END_OF_BUFFER_CHAR;
    buf[len + 1] = YY_END_OF_BUFFER_CHAR;

    ret = ag_yylex_init(&yyscanner);
    if (ret)
        elog(ERROR, "ag_yylex_init() failed: %m");

    strbuf_init(&extra.literal_buf, 1024);
    extra.high_surrogate = 0;
    extra.start_cond = INITIAL;
    extra.scan_buf = buf;
    extra.last_loc = 0;
    ag_yyset_extra(extra, yyscanner);

    ag_yy_scan_buffer(buf, len + 2, yyscanner);

    return yyscanner;
}

void ag_scanner_destroy(ag_scanner_t scanner)
{
    ag_yy_extra extra;

    extra = ag_yyget_extra(scanner);
    strbuf_cleanup(&extra.literal_buf);

    ag_yylex_destroy(scanner);
}

int ag_scanner_errmsg(const char *msg, ag_scanner_t *scanner)
{
    ag_yy_extra extra;

    extra = ag_yyget_extra(scanner);

    return _scan_errmsg(msg, &extra);
}

int ag_scanner_errposition(const int location, ag_scanner_t *scanner)
{
    ag_yy_extra extra;

    extra = ag_yyget_extra(scanner);

    return _scan_errposition(location, &extra);
}

